"""Tests for descriptor scripts"""
import unittest
from unittest import SkipTest
import os
import time
import shutil
import subprocess
import testhelper
import numpy as np
import descriptors.goldschmidt as dg
testname="descriptors/tests"
print "************************CURDIR:", os.getcwd()

class TestGoldschmidt(unittest.TestCase):
    def setUp(self):
        return
    
    def tearDown(self):
        return
    
    def test_calculate_goldschmidt(self):
        my_gold = dg.calculate_goldschmidt_pure(0.75,0.53,1.4)
        self.assertEqual("%3.3f" % my_gold, "0.788")
    def test_get_goldschmidt_category(self):
        self.assertEqual("not perovskite", dg.get_goldschmidt_category(0.5))
        self.assertEqual("orthorhombic or rhombohedral perovskite", dg.get_goldschmidt_category(0.85))
        self.assertEqual("cubic perovskite", dg.get_goldschmidt_category(0.89999))
        self.assertEqual("cubic perovskite", dg.get_goldschmidt_category(1.005))
        self.assertEqual("hexagonal perovskite", dg.get_goldschmidt_category(1.006))

