"""Tests for descriptor scripts"""
import unittest
from unittest import SkipTest
import os
import time
import shutil
import subprocess
import testhelper
import numpy as np
import descriptors.shannon_radii as sr
testname="descriptors/tests"
print "************************CURDIR:", os.getcwd()

class TestShannonRadii(unittest.TestCase):
    def setUp(self):
        return
    
    def tearDown(self):
        return
    def test_get_entries_from_shannon_dict(self):
        entrylist = sr.get_entries_from_shannon_dict("la",2,9,12,"")
        self.assertEquals(len(entrylist),0)
        entrylist = sr.get_entries_from_shannon_dict("la",3,9,12,"HS")
        self.assertEquals(len(entrylist),0)
        entrylist = sr.get_entries_from_shannon_dict("mn",3,6,6,"HS")
        self.assertEquals(len(entrylist),1)
        entrylist = sr.get_entries_from_shannon_dict("la",3,9,12,"")
        la1 = sr.get_entries_from_shannon_dict("la",3,9,9,"")
        la2 = sr.get_entries_from_shannon_dict("la",3,10,10,"")
        la3 = sr.get_entries_from_shannon_dict("la",3,12,12,"")
        builtlist=[la1[0],la2[0],la3[0]]
        self.assertListEqual(entrylist, builtlist)
        highlist = sr.get_entries_from_shannon_dict("la",3,9,12,"",1)
        self.assertListEqual(highlist, la3)
        noxlist = sr.get_entries_from_shannon_dict("f","","","","")
        self.assertEqual(len(noxlist),5)
        return


    def test_get_highest_cn_entries(self):
        entrylist=sr.get_entries_from_shannon_dict("la",3,9,12,"")
        highest = sr.get_highest_cn_entries(entrylist)
        la3 = sr.get_entries_from_shannon_dict("la",3,12,12,"")
        self.assertListEqual(highest, la3)
        return

    def test_match_single_entry_from_element(self):
        self.assertRaises(LookupError, sr.match_single_entry_from_element, "Mn",3,6,"",1)
        mymatch=sr.match_single_entry_from_element("Mn",3,6,3.8,1)
        self.assertEquals(mymatch.crystalrad, 0.785)
        mymatch=sr.match_single_entry_from_element("Mn",3,6,1.4,1)
        self.assertEquals(mymatch.crystalrad, 0.72)

        return
    def test_match_single_entry_from_element_highest_coordnum_match(self):
        self.assertRaises(LookupError, sr.match_single_entry_from_element_highest_coordnum_match, "Pr",3,2,"",1)
        mymatch=sr.match_single_entry_from_element_highest_coordnum_match("Pr",3,12,"",1)
        self.assertEquals(mymatch.crystalrad, 1.319)
        self.assertEquals(mymatch.coordnumber, 9)
        return
