#!/usr/bin/env python
# Tam Mayeshiba 2015-11-18
# cleanup from strain data
# M0 graphical abstract
######

import os
import subprocess
import numpy as np
import sys
import diffcoeffsupport
topdir="//home/tam/strain_emig_clean/M0_graphical_abstract"
noubarriers="//home/tam/strain_emig_clean/S4_migration_barriers/S4_migration_barriers_output"

fitdict=dict()

noufile = open(noubarriers, 'rb')
noulines = noufile.readlines()
noufile.close()
noulines_end = noulines
inip=0
indmeps=0
mylines=list()
for nouline in noulines:
    if ("DMEPS IP" in nouline):
        indmeps=1
    else:
        if (indmeps == 1) and (not ("DMEPS" in nouline)):
            mylines.append(nouline)
minslope=10000
maxslope=-10000
minb=""
maxb=""
for myline in mylines:
    print myline
    bsite = myline.split(",")[0]
    ipslope = float(myline.split(",")[1])
    if ipslope > maxslope:
        maxslope = ipslope
        maxb = bsite
    if ipslope < minslope:
        minslope = ipslope
        minb = bsite

print "Shallowest slope: %s, %3.3f" % (maxb, maxslope)
print "Steepest slope: %s, %3.3f" % (minb, minslope)

shallowslope = maxslope
shallowb = maxb
steepslope = minslope
steepb = minb

templow=300.0
temphigh=773.0

#Effects at 2% biaxial tensile strain
resdict=dict()
slist=[-2.0,-1.0,0.0,1.0,2.0]
for strain in slist:
    resdict[strain]=dict()
    for temp in [templow, temphigh]:
        resdict[strain][temp]=dict()
        resdict[strain][temp]['min'] = diffcoeffsupport.slope_to_change(shallowslope, strain, temp)
        resdict[strain][temp]['max'] = diffcoeffsupport.slope_to_change(steepslope, strain, temp)

print "percent strain,min effect %3.0fK, max effect %3.0fK, min effect %3.0fK, max effect %3.0fK" % (templow, templow, temphigh, temphigh)
for strain in slist:
    print "%3.1f,%3.3f,%3.3f,%3.3f,%3.3f" % (strain, 
        resdict[strain][templow]['min'],
        resdict[strain][templow]['max'],
        resdict[strain][templow]['min'],
        resdict[strain][temphigh]['max'])
