#!/usr/bin/env python
# Tam Mayeshiba 2015-11-18
# cleanup from strain data
# M3 literature slopes
######

import os
import subprocess
import numpy as np
import sys
import diffcoeffsupport
topdir="//home/tam/strain_emig_clean/M3_literature_slopes"
noubarriers="//home/tam/strain_emig_clean/S4_migration_barriers/S4_migration_barriers_output" 

fitdict=dict()

noufile = open(noubarriers, 'rb')
noulines = noufile.readlines()
noufile.close()
noulines_end = noulines
inip=0
indmeps=0
mylines=list()
for nouline in noulines:
    if ("DMEPS IP" in nouline):
        indmeps=1
    else:
        if (indmeps == 1) and (not ("DMEPS" in nouline)):
            mylines.append(nouline)
ipslopes=list()
oopslopes=list()
for myline in mylines:
    print myline
    bsite = myline.split(",")[0]
    ipslope = float(myline.split(",")[1])
    oopslope = float(myline.split(",")[3])
    ipslopes.append(ipslope)
    oopslopes.append(oopslope)

litdict=dict()

expt=dict()
expt['first_author'] = "Schichtel"
expt['source'] = "PhysChemChemPhys"
expt['year'] = 2009
expt['material'] = "YSZ/STO"
expt['dir'] = "IP"
expt['type'] = "Expt"
expt['slope'] = diffcoeffsupport.oom_to_slope(2.5, 573, 7.37) # 2.5 orders of magnitude increase in D at 573 K with lattice mismatch of 7.37
litdict['schichtel']=dict(expt)

expt=dict()
expt['first_author'] = "Kushima"
expt['source'] = "JMaterChem"
expt['year'] = 2010
expt['material'] = "YSZ"
expt['dir'] = "IP"
expt['type'] = "Calc"
expt['slope'] = diffcoeffsupport.oom_to_slope(3.8, 400, 4) 
litdict['kushima']=dict(expt)

expt=dict()
expt['first_author'] = "Kubicek"
expt['source'] = "ACSnano"
expt['year'] = 2013
expt['material'] = "LSC/LAO LSC/STO"
expt['dir'] = "OOP"
expt['type'] = "Expt"
expt['slope'] = diffcoeffsupport.oom_to_slope(np.log10(20), 673, 2.9) 
litdict['kubicek']=dict(expt)

expt=dict()
expt['first_author'] = "De Souza"
expt['source'] = "EnergyEnvironSci"
expt['year'] = 2012
expt['material'] = "CeO2 at +4% strain"
expt['dir'] = "IP"
expt['type'] = "Calc"
expt['slope'] = -0.9/14.0*1000.0
litdict['desouza1']=dict(expt)

expt=dict()
expt['first_author'] = "De Souza"
expt['source'] = "EnergyEnvironSci"
expt['year'] = 2012
expt['material'] = "CeO2"
expt['dir'] = "OOP"
expt['type'] = "Calc"
expt['slope'] = -100.0
litdict['desouza2']=dict(expt)

expt=dict()
expt['first_author'] = "Yang"
expt['source'] = ""
expt['year'] = 2013
expt['material'] = "BaTiO3"
expt['dir'] = "OOP"
expt['type'] = "Calc"
expt['slope'] = -70
litdict['yang']=dict(expt)

authors = litdict.keys()
print "Source;Slope of migration barrier versus strain (meV/percent strain), shallow bound, steep bound"
for author in authors:
    print "%s %s, %s %s, %s.;%3.3f" % (litdict[author]['dir'],
        litdict[author]['material'],
        litdict[author]['first_author'],
        litdict[author]['year'],
        litdict[author]['type'],
        litdict[author]['slope'])
print "IP average LaXO3, This paper;%3.3f,%3.3f,%3.3f" % (np.average(ipslopes),
        np.max(ipslopes), np.min(ipslopes))
print "OOP average LaXO3, This paper;%3.3f,%3.3f,%3.3f" % (np.average(oopslopes),
        np.max(oopslopes), np.min(oopslopes))




