#!/usr/bin/env python
# Tam Mayeshiba 2015-11-18
# cleanup from strain data
# M4 comparison to Kubicek experiment
######

import os
import subprocess
import numpy as np
import sys
import diffcoeffsupport
topdir="//home/tam/strain_emig_clean/M4_expt_comparison"
noubarriers="//home/tam/strain_emig_clean/S4_migration_barriers/S4_migration_barriers_output" 

fitdict=dict()

noufile = open(noubarriers, 'rb')
noulines = noufile.readlines()
noufile.close()
noulines_end = noulines
inip=0
indmeps=0
mylines=list()
for nouline in noulines:
    if ("DMEPS IP" in nouline):
        indmeps=1
    else:
        if (indmeps == 1) and (not ("DMEPS" in nouline)):
            mylines.append(nouline)
c_oopslope=""
for myline in mylines:
    print myline
    bsite = myline.split(",")[0]
    ipslope = float(myline.split(",")[1])
    oopslope = float(myline.split(",")[3])
    if bsite == "c": #only interested in Co oop slope for this comparison
        c_oopslope=oopslope

litdict=dict()

expt=dict()
expt['first_author'] = "Kubicek"
expt['source'] = "ACSnano"
expt['year'] = 2013
expt['material'] = "LSC/LAO LSC/STO"
expt['dir'] = "OOP"
expt['type'] = "Expt"
expt['slope'] = diffcoeffsupport.oom_to_slope(np.log10(20), 673, 2.9) 
litdict['kubicek']=dict(expt)

print "Change in migration barrier (eV) Normalized to 0eV at 0 strain"
print "% strain;OOP LSC/LAO LSC/STO, Kubicek 2013, Expt.;OOP LaCoO3, This paper"
for strain in [-1.9,0.0,1.0]:
    print "%3.1f;%3.3f;%3.3f" % (strain,
        litdict['kubicek']['slope'] * strain / 1000.0,
        c_oopslope * strain / 1000.0)
