#!/usr/bin/env python
# Tam Mayeshiba 2015-11-09
# cleanup from strain data
# S12 elastic model slopes
######

import os
import subprocess
import Vgetvolume
import hocking_lstsq
import numpy as np
import sys
import elastic_constants
topdir="//home/tam/strain_emig_clean/S12_elastic_model"
elasticfile=os.path.join(topdir, "S12_elastic_model_output")
volumefile=os.path.join(topdir,"S12d_migration_volumes_output")
#volumefile=os.path.join(topdir,"migration_volumes_from_paper")

import sys
fitdict=dict()
#blist=list(sys.argv[1])
blist=['c','f','g','m','n','r','s','t','v']

#Get prefactors previously calculated
bulkmodtailproc = subprocess.Popen("tail %s" % elasticfile, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
bulkmodtail = bulkmodtailproc.communicate()[0]
bulkmodlines = bulkmodtail.split("\n")
for bulkmodline in bulkmodlines:
    bulkmodsplit = bulkmodline.split(",")
    bsite = bulkmodsplit[0]
    if len(bsite) == 1:
        if not bsite in fitdict.keys():
            fitdict[bsite] = dict()
        prefactor = float(bulkmodsplit[8]) 
        prefactorerr = float(bulkmodsplit[9])
        fitdict[bsite]['prefactor'] = prefactor
        fitdict[bsite]['prefactorerr'] = prefactorerr

#Get migration volumes previously calculated
bulkmodtailproc = subprocess.Popen("tail %s" % volumefile, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
bulkmodtail = bulkmodtailproc.communicate()[0]
bulkmodlines = bulkmodtail.split("\n")
for bulkmodline in bulkmodlines:
    bulkmodsplit = bulkmodline.split(",")
    bsite = bulkmodsplit[0]
    if len(bsite) == 1:
        if not bsite in fitdict.keys():
            fitdict[bsite] = dict()
        fitdict[bsite]['v_mig_ip'] = float(bulkmodsplit[1])
        fitdict[bsite]['v_mig_oop'] = float(bulkmodsplit[2]) 
        fitdict[bsite]['volerr'] = 0.1*np.sqrt(2)
        fitdict[bsite]['v_mig_ip_volrelax'] = float(bulkmodsplit[3])
        fitdict[bsite]['v_mig_oop_volrelax'] = float(bulkmodsplit[4])
        fitdict[bsite]['volerr_volrelax'] = np.std([fitdict[bsite]['v_mig_ip_volrelax'], fitdict[bsite]['v_mig_oop_volrelax']])
print fitdict

for bsite in blist:
    [slope, slopeerr] = elastic_constants.strain_model_slope(fitdict[bsite]['prefactor'],fitdict[bsite]['prefactorerr'],fitdict[bsite]['v_mig_ip'],fitdict[bsite]['volerr'])
    fitdict[bsite]['ip_slope']=slope
    fitdict[bsite]['ip_slope_err']=slopeerr
    [slope, slopeerr] = elastic_constants.strain_model_slope(fitdict[bsite]['prefactor'],fitdict[bsite]['prefactorerr'],fitdict[bsite]['v_mig_oop'],fitdict[bsite]['volerr'])
    fitdict[bsite]['oop_slope']=slope
    fitdict[bsite]['oop_slope_err']=slopeerr
    [slope, slopeerr] = elastic_constants.strain_model_slope(fitdict[bsite]['prefactor'],fitdict[bsite]['prefactorerr'],fitdict[bsite]['v_mig_ip_volrelax'],fitdict[bsite]['volerr_volrelax'])
    fitdict[bsite]['ip_slope_volrelax']=slope
    fitdict[bsite]['ip_slope_err_volrelax']=slopeerr
    [slope, slopeerr] = elastic_constants.strain_model_slope(fitdict[bsite]['prefactor'],fitdict[bsite]['prefactorerr'],fitdict[bsite]['v_mig_oop_volrelax'],fitdict[bsite]['volerr_volrelax'])
    fitdict[bsite]['oop_slope_volrelax']=slope
    fitdict[bsite]['oop_slope_err_volrelax']=slopeerr

print "Bsite, BM IP slope, err, BM OOP slope, err, volrelax IP slope, err, volrelax OOP slope, err"
for bsite in blist:
    print "%s,%3.3f,%3.3f,%3.3f,%3.3f,%3.3f,%3.3f,%3.3f,%3.3f" % (bsite,
        fitdict[bsite]['ip_slope'],
        fitdict[bsite]['ip_slope_err'],
        fitdict[bsite]['oop_slope'],
        fitdict[bsite]['oop_slope_err'],
        fitdict[bsite]['ip_slope_volrelax'],
        fitdict[bsite]['ip_slope_err_volrelax'],
        fitdict[bsite]['oop_slope_volrelax'],
        fitdict[bsite]['oop_slope_err_volrelax'])



