#!/usr/bin/env python
# Tam Mayeshiba 2015-11-05
# cleanup from strain data
# S3 lattice fitting
######

import os
import subprocess
import Vgetenergy
import hocking_lstsq
topdir="//home/tam/strain_emig_clean/S3_lattice_fitting"
import sys
skiplist=list()
fitdict=dict()
#for bsite in ['c','f','g','m','n','r','s','t','v']:
for bsite in [sys.argv[1]]:
    fitdict[bsite] = dict()
    bdir = "%s/%sstretch" % (topdir, bsite)
    dir1s = os.listdir(bdir)
    bstretchdirs=list()
    for dir1 in dir1s:
        dir1path = os.path.join(bdir, dir1)
        if os.path.isdir(dir1path) and not ("skip" in dir1): #ignore files and skip folders
            dir2s = os.listdir(dir1path)
            for dir2 in dir2s:
                dir2path = os.path.join(dir1path, dir2)
                if os.path.isdir(dir2path):
                    bstretchdirs.append(dir2path)
    for bsdir in bstretchdirs:
        astrain=""
        cstrain=""
        energy=""
        #print bsdir
        odir = os.path.join(bsdir, "stat", "OSZICAR")
        if os.path.isfile(odir):
            energy = Vgetenergy.main(os.path.join(bsdir, "stat"))
            #print energy
        else:
            skiplist.append("%s: does not exist" % odir)
            continue
        idir = os.path.join(bsdir, "input.inp")
        if os.path.isfile(idir):
            grepstrain = subprocess.Popen("grep mast_strain %s" % idir, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
            strainstring = grepstrain.communicate()[0]
            astrain = strainstring.split()[1]
            cstrain = strainstring.split()[3]
        else:
            grepstrain = subprocess.Popen("grep mast_strain %s/*input.py" % bsdir, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
            strainstring = grepstrain.communicate()[0]
            strainsplit = strainstring.split()
            astrain = strainsplit[2].split("'")[1]
            cstrain = strainsplit[4].split("'")[0]
        if (astrain=="") or (cstrain=="") or (energy==""):
            skiplist.append("%s: error" % bsdir)
            continue
        #print "%s:%s:%s:%s" % (bsite, astrain, cstrain, energy)
        if not astrain in fitdict[bsite].keys():
            fitdict[bsite][astrain]=dict()
            fitdict[bsite][astrain]['cstrains']=list()
            fitdict[bsite][astrain]['energies']=list()
        fitdict[bsite][astrain]['cstrains'].append(float(cstrain))
        fitdict[bsite][astrain]['energies'].append(float(energy))

import simpleplot
import numpy as np
import time
bsites = fitdict.keys()
bsites.sort()
for bsite in bsites:
    astrains = fitdict[bsite].keys()
    astrains.sort()
    for astrain in astrains:
        print "BSITE: ", bsite
        print "ASTRAIN: ", astrain
        clist = fitdict[bsite][astrain]['cstrains']
        cvec = np.array(clist, 'float')
        elist = fitdict[bsite][astrain]['energies']
        evec = np.array(elist, 'float')
        print "Cvec, Evec: ", cvec, evec
        simpleplot.plot(cvec, evec, "Bsite %s: a-strain %s" % (bsite, astrain))
        [betamat, ssq, betaerr] = hocking_lstsq.least_squares_regression(cvec, evec, 3)
        fitdict[bsite][astrain]['fit_s'] = np.power(ssq, 0.5)
        coeffa=float(betamat[3])
        coeffb=float(betamat[2])
        coeffc=float(betamat[1])
        deriva = 3.0 * coeffa #times x^2
        derivb = 2.0 * coeffb #times x
        derivc = coeffc # intercept of derivative
        #let's solve the quadratic equation!
        #[-b +/- sqrt(b^2 - 4ac)]/ 2a
        insqrtterm = np.power(derivb, 2) - 4.0*deriva*derivc
        #print "In sqrt: ", insqrtterm
        sqrtterm = np.power(insqrtterm, 0.5)
        topterm1 = -1.0*derivb + sqrtterm
        topterm2 = -1.0*derivb - sqrtterm
        solve1 = topterm1 / (2.0 * deriva)
        solve2 = topterm2 / (2.0 * deriva)
        lowerbound=0.95
        upperbound=1.05
        results="RESULTS: "
        if (solve1 <= upperbound) and (solve1 >= lowerbound): 
            results = results + str(solve1)
        if (solve2 <= upperbound) and (solve2 >= lowerbound):
            results = results + ":" + str(solve2)
        print results
        fitdict[bsite][astrain]['results'] = results
print "B-site:a strain: fit S:results"
for bsite in bsites:
    for astrain in astrains:
        print "%s:%s:%3.3f:%s" % (bsite, astrain, 
            fitdict[bsite][astrain]['fit_s'],
            fitdict[bsite][astrain]['results'])


            





