#!/usr/bin/env python
# Tam Mayeshiba 2015-11-17
# cleanup from strain data
# S6 literature barriers for no-strain comparison
######

import os
import subprocess
import numpy as np
import sys
import nebenergy
topdir="//home/tam/strain_emig_clean/S6_literature_barriers"

addldir="//home/tam/strain_emig_clean/S5_GGAU_barrier_comparison"
#
#blist=list(sys.argv[1])
litdirs = os.listdir("%s/literature" % topdir)
blist=['c','f','g','m','n','r','s','t','v']
fitdict=dict()
for bsite in blist:
    fitdict[bsite]=dict()
    for litdir in litdirs:
        litsplit = litdir.split("_")
        if litsplit[0] == bsite:
            litfile = open(os.path.join(topdir,"literature",litdir), 'rb')
            litlines = litfile.readlines()
            litfile.close()
            for litline in litlines:
                if "E_activation" in litline:
                    if "eV" in litline:
                        litval = litline.split(":")[1]
                        if not ('lit' in fitdict[bsite].keys()):
                            fitdict[bsite]['lit'] = list()
                        fitdict[bsite]['lit'].append(float(litval))

for bsite in blist:
    
    nebrpt_comp = nebenergy.report("%s/nonu/a%sc/a%sc_neb_static" % (addldir, bsite, bsite))
    fitdict[bsite]['nonu_comp']=nebrpt_comp['barrfrominit']
    nebrpt_uncomp = nebenergy.report("%s/nonu_uncompensated/a%s/a%s/a%s_neb_static" % (topdir, bsite, bsite, bsite))
    fitdict[bsite]['nonu_uncomp']=nebrpt_uncomp['barrfrominit']
print "Barriers from first endpoint, no strain"
displist=list()
maxlits=0
for bsite in blist:
    dispstr = "%s,%3.3f,%3.3f" % (bsite,fitdict[bsite]['nonu_comp'],fitdict[bsite]['nonu_uncomp'])
    if 'lit' in fitdict[bsite].keys():
        litct=0
        for myval in fitdict[bsite]['lit']:
            dispstr = dispstr + ",%3.3f" % myval
            litct=litct+1
        if litct > maxlits:
            maxlits = litct
    displist.append(dispstr)
headstr = "B-site, GGA comp, GGA uncomp"
litct=1
while litct <= maxlits:
    headstr = headstr + ",lit"+str(litct)
    litct = litct + 1
print headstr
for dispitem in displist:
    print dispitem
