#!/usr/bin/env python
# Tam Mayeshiba 2015-11-17
# cleanup from strain data
# S6 magnetic moment ferromagnetic data for Table S6.1
######

import os
import subprocess
import numpy as np
import sys
import nebenergy
import Vgettotmom
topdir="//home/tam/strain_emig_clean/S6_magnetic_moment"
addldir1="//home/tam/strain_emig_clean/S5_GGAU_barrier_comparison/nonu"
addldir2="//home/tam/strain_emig_clean/S6_literature_barriers/nonu_uncompensated"

fitdict=dict()

#
#blist=list(sys.argv[1])
blist=['c','f','g','m','n','r','s','t','v']


for bsite in blist:
    fitdict[bsite]=dict()
    pathlist=list()
    pathlist.append(["bulk","%s/a%s/a%s/a%s_bulk_static" % (addldir2, bsite, bsite, bsite)])
    pathlist.append(["ep1_uncomp","%s/a%s/a%s/a%s_ep1_static" % (addldir2, bsite, bsite, bsite)])
    pathlist.append(["neb_uncomp","%s/a%s/a%s/a%s_neb_static/02static" % (addldir2, bsite, bsite, bsite)])
    pathlist.append(["ep1_comp","%s/a%sc/a%sc_ep1_static" % (addldir1, bsite, bsite)])
    pathlist.append(["neb_comp","%s/a%sc/a%sc_neb_static/02static" % (addldir1, bsite, bsite)])

    for pathitem in pathlist:
        totmoment = Vgettotmom.main(pathitem[1])
        moment = float(totmoment)/8.0 #8 formula units
        fitdict[bsite][pathitem[0]]=moment
print "Magnetic moment per B-site cation in LaBO3 perovskites, when relaxed from high-spin ferromagnetic configuration, Bohr magnetons"
print "B-site,Bulk,Uncompensated endpoint, Uncompensated middle image, Compensated endpoint, Compensated middle image"
for bsite in blist:
    print "%s,%3.3f,%3.3f,%3.3f,%3.3f,%3.3f" % (bsite,fitdict[bsite]['bulk'],fitdict[bsite]['ep1_uncomp'],fitdict[bsite]['neb_uncomp'],fitdict[bsite]['ep1_comp'],fitdict[bsite]['neb_comp'])
