#!/usr/bin/env python
# Tam Mayeshiba 2015-11-18
# cleanup from strain data
# S7 doped versus electron removal compensation
######

import os
import subprocess
import numpy as np
import sys
import nebenergy
topdir="//home/tam/strain_emig_clean/S7_doped_vs_electron_removal"
addldir="//home/tam/strain_emig_clean/S5_GGAU_barrier_comparison"
fitdict=dict()

#
#blist=list(sys.argv[1])
blist=['c','f','g','m','n','r','s','t','v']

for bsite in blist:
    fitdict[bsite]=dict()
    nebrpt_er = nebenergy.report("%s/nonu/a%sc/a%sc_neb_static" % (addldir, bsite, bsite))
    fitdict[bsite]['er']=nebrpt_er['barrfrominit']
    nebrpt_dop = nebenergy.report("%s/a%sd/a%sd/a%sd_neb_static" % (topdir, bsite, bsite, bsite))
    fitdict[bsite]['dop']=nebrpt_dop['barrfrominit']
print "Barriers from first endpoint, no strain"
print "B-site,electron-removal compensated, doped, compensated minus doped"
difflist=list()
for bsite in blist:
    difference = fitdict[bsite]['er']-fitdict[bsite]['dop']
    print "%s,%3.3f,%3.3f,%3.3f" % (bsite,fitdict[bsite]['er'],fitdict[bsite]['dop'],difference)
    difflist.append(difference)

print "Largest value: %3.3f" % max(difflist)
print "Mean value: %3.3f" % np.average(difflist)
