#!/usr/bin/env python
# Tam Mayeshiba 2015-11-18
# cleanup from strain data
# S8 eight hops for B-site cations, Table S8.2
######

import os
import subprocess
import numpy as np
import sys
import nebenergy
topdir="//home/tam/strain_emig_clean/S8_hop_directions/eighthops"


fitdict=dict()

planelist=['inplane','ooplane']
iplist=['o30to19','o30to25','o30to31','o30to37']
ooplist=['o30to17','o30to20','o30to29','o30to32']

dirlist = os.listdir(topdir)
dirlist.sort()
for mydir in dirlist:
    trydir = os.path.join(topdir, mydir)
    if os.path.isdir(trydir):
        if "eighthops" in mydir:
            bsite = mydir.split("_")[0]
            if not (bsite in fitdict.keys()):
                fitdict[bsite]=dict()
            compstat = mydir.split("_")[2]
            if not (compstat in fitdict[bsite].keys()):
                fitdict[bsite][compstat] = dict()
            for plane in planelist:
                fitdict[bsite][compstat][plane] = dict()
                if plane == 'inplane':
                    jumplist = iplist
                else:
                    jumplist = ooplist
                for jumpdir in jumplist:
                    if os.path.isdir(os.path.join(trydir, plane, jumpdir)):
                        nebdirs = os.listdir(os.path.join(trydir, plane, jumpdir))
                        for nebdir in nebdirs:
                            if ("neb_static" in nebdir):
                                nebrpt = nebenergy.report(os.path.join(trydir, plane, jumpdir, nebdir))
                                if (jumpdir == "o30to29") and ("link" in nebdir): # want backwards hop
                                    fitdict[bsite][compstat][plane][jumpdir]=nebrpt['barrfromfin']
                                else:
                                    fitdict[bsite][compstat][plane][jumpdir]=nebrpt['barrfrominit']

blist = fitdict.keys()
blist.sort()
displist=list()
for bsite in blist:
    for compstat in fitdict[bsite].keys():
        dispstr = "%s %s" % (bsite, compstat)
        for ipdir in iplist:
            if ipdir in fitdict[bsite][compstat]['inplane'].keys():
                dispstr = dispstr + ",%3.3f" % fitdict[bsite][compstat]['inplane'][ipdir]
            else:
                dispstr = dispstr + ","
        for oopdir in ooplist:
            if oopdir in fitdict[bsite][compstat]['ooplane'].keys():
                dispstr = dispstr + ",%3.3f" % fitdict[bsite][compstat]['ooplane'][oopdir]
            else:
                dispstr = dispstr + ","
        displist.append(dispstr)


headerstr="B-site"
for ipdir in iplist:
    headerstr = headerstr + ",IP %s" % ipdir
for oopdir in ooplist:
    headerstr = headerstr + ",OOP %s" % oopdir
print headerstr
for dispitem in displist:
    print dispitem
