"""Tests for strain scripts"""

import unittest
from unittest import SkipTest
import os
import time
import shutil
import subprocess
import testhelper
testname="strain_emig_scripts/tests"
print "************************CURDIR:", os.getcwd()

class TestStrainEmig(unittest.TestCase):
    def setUp(self):
        self.myscripts=list()
        
        self.myscripts.append("M0_graphical_abstract")
        self.myscripts.append("M3_literature_slopes")
        self.myscripts.append("M4_expt_comparison")
        self.myscripts.append("S12d_migration_volumes")
        self.myscripts.append("S12_elastic_model")
        
        self.myscripts.append("S12_epneb_bulkmod")
        self.myscripts.append("S12_model_slopes")
        self.myscripts.append("S3_bulk_supercells")
        self.myscripts.append("S3_lattice_fitting v")
        self.myscripts.append("S4_migration_barriers")
        
        self.myscripts.append("S5_GGAU_barriers")
        self.myscripts.append("S6_literature_barriers")
        self.myscripts.append("S6_magnetic_moment_afm")
        self.myscripts.append("S6_magnetic_moment_fm")
        self.myscripts.append("S7_doped_barriers in_line")
        
        self.myscripts.append("S7_doped_fitting in_line")
        self.myscripts.append("S7_doped_vs_electron_removal")
        self.myscripts.append("S8_eighthops")
        self.myscripts.append("S8_full_barriers")
        self.myscripts.append("S8_low_strain_fit_full")
        
        return
    
    def tearDown(self):
        myfiles=os.listdir(os.getcwd())
        for myfile in myfiles:
            if myfile[0:10] == "testoutput":
                os.remove(myfile)
            elif myfile[0:9] == "newoutput":
                os.remove(myfile)
        return

    def create_tail_script_standards(self, scriptname=""):
        scriptlist=scriptname.split()
        scriptcmd="python ~/pvhelper/strain_emig_scripts/%s.py" % scriptlist[0]
        if len(scriptlist) == 2:
            scriptcmd = scriptcmd + " " + scriptlist[1]
        fulloutput="testoutput_%s" % scriptname
        lastoutput="stdoutput_%s" % scriptname
        testhelper.generic_run(scriptcmd, fulloutput)
        testhelper.last_X_lines(fulloutput, lastoutput, 10)
        return
    def create_tail_new(self, scriptname=""):
        scriptlist=scriptname.split()
        scriptcmd="python ~/pvhelper/strain_emig_scripts/%s.py" % scriptlist[0]
        if len(scriptlist) == 2:
            scriptcmd = scriptcmd + " " + scriptlist[1]
        fulloutput="testoutput_%s" % scriptname
        lastoutput="newoutput_%s" % scriptname
        testhelper.generic_run(scriptcmd, fulloutput)
        testhelper.last_X_lines(fulloutput, lastoutput, 10)
        return
    def test_create_standards(self):
        print "Standards should already have been created. Skipping here."
        raise SkipTest
        for myscript in self.myscripts:
            self.create_tail_script_standards(myscript)
        self.assertTrue(True)

    def test_each_script(self):
        for myscript in self.myscripts:
            print "Name: %s" % myscript
            self.create_tail_new(myscript)
            scriptname=myscript.split()[0]
            okay = testhelper.is_same_as_standard("newoutput_%s" % scriptname,
                    "stdoutput_%s" % scriptname)
            self.assertTrue(okay)
        return
