#!/usr/bin/env python
##
#@package   Platticevec
#@ingroup   vasp
#@ingroup   python
#@brief     fractional coordinates to cartesian coordinates
#@author    Tam Mayeshiba
#@date      6/4/12 truncated from Pfractocart
###
def main(dirname, fname):
    """
    Purpose:
        inputs:  
            [$1] directory 
            example:
            [$2] filename (CONTCAR or POSCAR, with species line 
            (atoms must start at line 9)
        outputs:
            matrix of cartesian lattice vectors
    """
#   Modules:
    import os
    import sys
    import Xvector
    import Pgetline
    import Xvaliddirectory
#   
#   #  
    dirname = Xvaliddirectory.main(dirname)
    if dirname == None:
        return None
    fullpath=""
    fullpath = os.path.join(dirname, fname)
    if not os.path.isfile(fullpath):
        print 'Could not find', fullpath, '. Exiting.'
        return None
    myline=Pgetline.main(dirname, fname, 0, 8)
    if myline == None:
        print 'Error getting line 8 from', fullpath, '. Exiting.'
        return None
    try:
        if (myline.strip()[0]).isdigit():
            print fullpath, 'is not in VASP version 5 format. Exiting.'
            return None
    except (IndexError):
        print 'Index error in getline return.'
        return None
    fmat=[]
    myread=""
    myread = open(fullpath, 'rb')
    lmat=[]
    lmat = myread.readlines()
    myread.close()
    fmat = lmat[8:]
    if not float(lmat[1]) == 1:
        print 'Scaling vector must be 1 for this function. Exiting.'
        return None
    lv1=Xvector.strtoflt(lmat[2])
    lv2=Xvector.strtoflt(lmat[3])
    lv3=Xvector.strtoflt(lmat[4])
    return [lv1,lv2,lv3]
