#!/usr/bin/env python
####################
# TTM 2015-09-011
# Cut-and-paste hocking least squares fit
#####################

import numpy as np
import sys

def get_vectors(totlist):
    xlist=list()
    ylist=list()
    for myitem in totlist:
        mysplit=myitem.split()
        try:
            xlist.append(mysplit[0].strip())
            ylist.append(mysplit[1].strip())
        except:
            print "Value ignored: %s" % myitem
    xvec=np.array(xlist,'float')
    yvec=np.array(ylist,'float')
    return [xvec,yvec]

def do_fit(xvec,yvec,fitorder):
    import hocking_lstsq
    myfit=hocking_lstsq.least_squares_regression(xvec,yvec,fitorder)
    return myfit

def main(totlist=list(),fitorder=1):
    [xvec,yvec]=get_vectors(totlist)
    do_fit(xvec,yvec,int(fitorder))
    return

if __name__=="__main__":
    if len(sys.argv) > 1:
        fitorder=sys.argv[1]
    else:
        fitorder=1
    print "Cut and paste the x, y values for fitting here."
    totlist=list()
    mylist="initialize"
    while (not mylist==""):
        mylist=raw_input("prompt: ")
        if not mylist=="":
            totlist.append(mylist)
    main(totlist, fitorder)
