function headers(mydata)
%> @namespace headers
%> @ingroup   plotting
%> @ingroup   matlab
%> @brief     Display column number and name for data imported using importme
%> @verbatim  headers(mydata) @endverbatim
%> @param     mydata Dataset containing columns of data
%> @author    Tam Mayeshiba
%> @date      10/24/11 created

headers = fieldnames(mydata); % or, headers = mydata.Properties.VarNames

numbered = {[1:length(headers)];headers};
nlist = transpose(numbered);
for i=1:length(headers)
    %display([nlist{1}(i),nlist{2}(i)]);
    fprintf('%d %s\n', nlist{1}(i), nlist{2}{i});
end

%SPECIFIC TO TAM'S PLOTS
%transpose(getlabels(mydata.calcDetail))

end

