function largelegend(figurenumber)
%> @namespace largelegend
%> @ingroup   plotting
%> @ingroup   matlab
%> @brief     Increase legend icon size of the specified figure.
%> @details   This is usually necessary when opening up a saved figure.
%> @verbatim  largelegend(1) @endverbatim
%> @param     figurenumber Matlab figure number (found in open figure's title bar)
%> @author    Tam Mayeshiba
%> @date      10/24/11 created

leglinewidth=2.4;
legmarksize=10;

figure(figurenumber)
legendobj = findobj(gcf,'tag','legend'); 
legend_children = get(legendobj,'Children');
for i=1:length(legend_children)
    if strcmp(get(legend_children(i),'Type'),'hggroup')
        set(get(legend_children(i),'Children'),'LineWidth',leglinewidth,'MarkerSize',legmarksize)
    end
end


end

