#!/usr/bin/env python
##
#@package   Pmakemonfile 
#@ingroup   vasp
#@ingroup   python
#@brief     make a monitor file (for use in other scripts)
#@author    Tam Mayeshiba
#@date      3/23/11 copied from Pdirautorelaxsilent
###
def main(fullpath):
    """
    Purpose: make a monitor file name to send to other scripts to house
             standard output
       inputs:  
	        [$1] full path of folder of starting job
                example: '/home/tam/rocksalt_rel1/NaClep1'
       outputs:
            string of full monitor file path
            None - error
    """
#   Modules:
    import os
    import sys
    import subprocess
    import Xtimestring
    import Xuniquename
    import Xvaliddirectory
#   Validation
#   #   direcory
    fullpath = Xvaliddirectory.main(fullpath)
    if (fullpath == None):
        print '(Exiting.)'
        return None
#   set up output file
    filestr=""
    fileme=""
    print fullpath
    filestr = 'mon' + Xtimestring.main()
    filestr = filestr + os.path.basename(fullpath) + '_'
    filestr = Xuniquename.main(fullpath, filestr, 'f', '', 1, 100)
    if (filestr == None):
        print 'Unique filename could not be created.'
        print '(Exiting.)'
        return None
    filestr = fullpath + '/' + filestr
    return filestr
