#!/usr/bin/env python
##
#@package   Pmodinput
#@ingroup   vasp
#@ingroup   python
#@brief     modify input file to folder name and path
#@author    Tam Mayeshiba
#@date      8/19/11 created
#@date      8/26/11 fixed bug with replacing wrong line
#@date      7/4/12 copied from Pmodsubs
###
def main(existdir, mindepth=1, maxdepth=1, fname='inputfile'):
    """
    Purpose: modify input file to folder name
        inputs:  
            [$1] directory in which to modify
            example: /home/tam/rocksalts
            [$2] minimum levels deep (1-5)
                default 1
            [$3] maximum levels deep (1-5)
                default 1
        outputs:
            None if error
            True if successful
    """
#   Modules:
    import os
    import sys
    import Xvaliddirectory
    import Xvalidinteger
    import Xgetdirs
    import Psubfile
    import Pmodfilenew
    import Pgetline
    import Pgetseg
#   Validation
#   #  existdir
    existdir = Xvaliddirectory.main(existdir)
    if (existdir == None):
        print '(Exiting.)'
        return None
#   #   mindepth
    mindepth = Xvalidinteger.main(mindepth, 1, 5)
    if (mindepth == None):
        print '(Exiting.)'
        return None
#   #   maxdepth
    maxdepth = Xvalidinteger.main(maxdepth, 1, 5)
    if (maxdepth == None):
        print '(Exiting.)'
        return None
#   get directories
    dirlist=[]
    mydir=""
    dirlist = Xgetdirs.main(existdir, mindepth, maxdepth)
    if (dirlist == None):
        print 'Error getting directories under', existdir
        print '(Exiting.)'
        return None
    if len(dirlist) == 0:
        print 'No directories found under', existdir
        print 'levels', mindepth, 'to', maxdepth
        print '(Exiting.)'
        return None
#   modify submission files
    mysub=""
    mysubname=""
    nameline=""
    nameseg=""
    dirshort=""
    newline=""
    modokay=""
    collectionpath=""
    calcgrouppath=""
    calcgroupname=""
    fullpath=""
    for mydir in dirlist:
        fullpath = os.path.join(mydir, fname)
        if os.path.isfile(fullpath):
            calcgroupname = os.path.basename(mydir)
            calcgrouppath = mydir
            collectionpath = os.path.dirname(mydir)
            Pmodfilenew.main(mydir, fname, 'calcgroup_name', 'X', 'R',
                'calcgroup_name = ' + calcgroupname)
            Pmodfilenew.main(mydir, fname, 'calcgroup_path', 'X', 'R',
                'calcgroup_path = ' + calcgrouppath)
            Pmodfilenew.main(mydir, fname, 'collection_path', 'X', 'R',
                'collection_path = ' + collectionpath)
            print 'Modified', fullpath
    return True
    
