#!/usr/bin/env python
##
#@package   Pmodsubs 
#@ingroup   vasp
#@ingroup   python
#@brief     modify several submission scripts to folder name
#@author    Tam Mayeshiba
#@date      8/19/11 created
#@date      8/26/11 fixed bug with replacing wrong line
###
def main(existdir, mindepth=1, maxdepth=1):
    """
    Purpose: modify several submission scripts to folder name
        inputs:  
            [$1] directory in which to modify
            example: /home/tam/rocksalts
            [$2] minimum levels deep (1-5)
                default 1
            [$3] maximum levels deep (1-5)
                default 1
        outputs:
            None if error
            True if successful
    """
#   Modules:
    import os
    import sys
    import Xvaliddirectory
    import Xvalidinteger
    import Xgetdirs
    import Psubfile
    import Pmodfilenew
    import Pgetline
    import Pgetseg
#   Validation
#   #  existdir
    existdir = Xvaliddirectory.main(existdir)
    if (existdir == None):
        print '(Exiting.)'
        return None
#   #   mindepth
    mindepth = Xvalidinteger.main(mindepth, 1, 5)
    if (mindepth == None):
        print '(Exiting.)'
        return None
#   #   maxdepth
    maxdepth = Xvalidinteger.main(maxdepth, 1, 5)
    if (maxdepth == None):
        print '(Exiting.)'
        return None
#   get directories
    dirlist=[]
    mydir=""
    dirlist = Xgetdirs.main(existdir, mindepth, maxdepth)
    if (dirlist == None):
        print 'Error getting directories under', existdir
        print '(Exiting.)'
        return None
    if len(dirlist) == 0:
        print 'No directories found under', existdir
        print 'levels', mindepth, 'to', maxdepth
        print '(Exiting.)'
        return None
#   modify submission files
    mysub=""
    mysubname=""
    nameline=""
    nameseg=""
    dirshort=""
    newline=""
    modokay=""
    for mydir in dirlist:
        dirshort = os.path.basename(os.path.normpath(mydir))
        mysub = Psubfile.main(mydir)
        if (mysub == None):
            print 'Error getting submission file for', mydir
        else:
            mysubname = os.path.basename(mysub)
            nameline = Pgetline.main(mydir, mysubname, '-N', 'X', 1, 0)
            if (nameline == None):
                print 'Error isolating name line.'
            else:
                nameseg = Pgetseg.main(nameline, 1, '-N')
                if (nameseg == None):
                    print 'Error getting name heading segment.'
                else:
                    newline = nameseg + '-N ' + dirshort
                    modokay = Pmodfilenew.main(mydir, mysubname,
                                nameseg + '-N', 'X', 'R', newline)
                    if (modokay == None):
                        print 'Error modifying', mysub
                    else:
                        print 'Modified', mysub
    return True
    
