#!/usr/bin/env python
##
#@package   Pmultkpts
#@ingroup   vasp
#@ingroup   python
#@brief     multiplies kpoints in KPOINTS together
#@author    Tam Mayeshiba
#@date      3/25/11 created
###
def main(existdir):
    """
    Purpose: multiplies kpoints in KPOINTS together
        inputs:  
            [$1] run directory
            example: /home/tam/NaCl
        outputs:
            integer of multiplied kpoints
            None if error
    """
#   Modules:
    import os
    import sys
    import Xvaliddirectory
    import Pgetline
#   Validation
#   #  directory
    existdir = Xvaliddirectory.main(existdir)
    if (existdir == None):
        print '(Exiting.)'
        return None
#   get KPOINTS line
    kptline=""
    kptline = Pgetline.main(existdir, 'KPOINTS', 0, 4)  #4th line
    kptlist=[]
    kptlist = kptline.split()
    onekpt=""
    onekptint=0
    kptmult=1
    for onekpt in kptlist:
        if not onekpt.isdigit():
            print 'Something is wrong with the KPOINTS file in', existdir
            print '(Exiting.)'
            return None #   something is wrong with the KPOINTS file
        try:
            onekptint = int(onekpt)
        except (ValueError, TypeError):
            print 'A KPOINT value in', existdir, 'could not be converted.'
            print '(Exiting.)'
            return None #   something is wrong with the KPOINTS file
        kptmult = kptmult * onekptint
    return kptmult
