#!/usr/bin/env python
##
#@package   Prandomperturb
#@ingroup   vasp
#@ingroup   python
#@brief     randomly perturb values
#@author    Tam Mayeshiba
#@date      
###
def main(mydir="",angstroms=0.1,fname="POSCAR"):
    """
    Purpose: randomly perturb POSCAR coordinates. Each a,b,c 
            coordinate has a 50/50 chance of being perturbed,
            and then a 50/50 chance of positive or negative
            perturbation.
        inputs:  
            [$1] mydir = directory
            [$2] angstroms = angstrom amount to perturnb
            [$3] filename within the directory
            example:
        outputs:
    """
#   Modules:
    import os
    import sys
    import random
    import Xuniquename
#   
#   #  
    angflt = float(angstroms)
    fullpath = os.path.join(mydir, fname)
    if not os.path.isfile(fullpath):
        print "No such file at", fullpath
        return None
    myfile = open(fullpath, 'rb')
    mylines = myfile.readlines()
    myfile.close()
    myline=""
    numlines = len(mylines)
    if numlines == 0:
        print "No lines. Exiting."
        return None
    newlines=[]
    for idx in range(0,8):
        print mylines[idx]
        newlines.append(mylines[idx])
    random.seed()
    for idx in range(8,numlines):
        myline = mylines[idx]
        mylist = myline.split()
        strlist=[]
        for cidx in range(0,3):
            perturb = random.choice([0,0,1,-1])
            myperturb = float(perturb)*angflt
            oldval = float(mylist[cidx])
            newval = oldval + myperturb
            newstr = str(newval)
            strlist.append(newstr)
        if len(mylist) > 3:
            strlist.append(mylist[3])
        strlist.append('\n')
        newline = ' '.join(strlist)
        newlines.append(newline)
    newname = Xuniquename.main(mydir,"POSCAR","F","_perturb_")
    if not newname == None:
        newfile = open(newname,'wb')
        newfile.writelines(newlines)
        return True
    return None


