#!/usr/bin/env python
##
#@package   Psendemail
#@ingroup   other
#@ingroup   python
#@brief     send email (for error messages)
#@author    Tam Mayeshiba
#@date      2/16/11 created
###
def main(emaddress='', emsubject='Test', emmessage='Test message.'):
    """
    Purpose:
        inputs:  
            [$1] email address
            example: 'bucky@wisc.edu'
            [$2] subject, in quotes
            example: 'run failed'
            [$3] message, in quotes
            example: 'Please check directory.'
        outputs:
            None if error sending
            True if sent successfully
        Notes:
            email address format is not currently checked.
    """
#   Modules:
    import os
    import sys
    import smtplib
    import email
#   Validation
#   #  
    if type(emsubject) != str:
        print 'Email subject should be a string.'
        print '(Exiting.)'
        return None
    if type(emmessage) != str:
        print 'Email message should be a string.'
        print '(Exiting.)'
        return None
    if type(emaddress) != str:
        print 'Email address should be a string.'
        print '(Exiting.)'
        return None
#   Send email
    sess=""
    msg=""
    msg = email.message_from_string(emmessage)
    msg['Subject'] = emsubject
    msg['From'] = 'Automatam'
    msg['To'] = emaddress
    sess=smtplib.SMTP("localhost")
    sess.sendmail(emaddress, emaddress, msg.as_string()) 
    sess.quit()
    return True
