#!/usr/bin/env python
##
#@package   Psubfile
#@ingroup   vasp
#@ingroup   python
#@brief     find submission script for one directory
#@note      returns full path of submission script
#@author    Tam Mayeshiba
#@date      3/23/11 copied out of Prunone
###
def main(existdir):
    """
    Purpose: find submission script for one directory, return full path
        inputs:  
            [$1] directory in which to run script
                 example: /home/tam/starts/
        returns:
            None if error
            full path of submission script
        outputs: outputs to screen
        note: only goes one level deep
              if more than one submission script is found, returns most recent
    """
#   Modules:
    import os
    import sys
    import shutil
    import Xvaliddirectory
    import Xgetfiles
#   Validation
#   #   validate directory path
    existdir = Xvaliddirectory.main(existdir)
    if (existdir == None):
        print '(Exiting.)'
        return None
#   find submission scripts
    filelist=[]
    fileitem=""
    sublist=[]
    subitem=""
    substat=()
    subtimes=[]
    substatlist=[]
    subtime=""
    numsubs=0
    subfilestr=""
    subfilesplit=[]
    subfile=""
    filelist = Xgetfiles.main(existdir, 1, 1) #only look 1 level deep
    for fileitem in filelist:
        if (fileitem[-3:] == '.sh'):
            sublist.append(fileitem)
    numsubs = len(sublist)
    if (numsubs == 0):
        print 'No submission scripts detected!'
        print '(Exiting.)'
        return None
    elif (numsubs > 1):
        print 'Warning: more than 1 submission script detected.'
        print 'Using most recent one.'
        for subitem in sublist:
            substat = os.stat(subitem)
            substatlist = list(substat)
            subtime = substatlist[8] # most recent modification
            subtimes.append(str(subtime) + ':' + subitem)
            subtimes.sort()
        subfilestr = subtimes[numsubs-1] #last one has largest timestamp
        subfilesplit = subfilestr.split(':')
        subfile = subfilesplit[1]
        print subfile
    else:
        subfile = sublist[0]
    return subfile
