#!/usr/bin/env python
##
#@package   Sgetpyfiles
#@ingroup   other
#@ingroup   python
#@brief     gets python files from directory
#@author    Tam Mayeshiba
#@date      8/3/11 - created
###
def main(scriptdir=""):
    """
    Purpose: gets python files from directory
        inputs:  
            [$1] tscripts installation directory
            example:
        outputs:
            None if error
            list of .py python source files 
    """
#   Modules:
    import os
    import sys
    import Xvaliddirectory
    import Xgetfiles
    import Sgettags
#   Validation
#   #  scriptdir
    if (scriptdir == ""):
        scriptdir = os.path.join(os.environ["HOME"], 'bin/tscripts')
        print "Using script directory:", scriptdir
    scriptdir = Xvaliddirectory.main(scriptdir)
    if (scriptdir == None):
        print '(Exiting.)'
        return None
#   Get python files
    allfiles=[]
    onefile=""
    pyfiles=[]
    allfiles = Xgetfiles.main(scriptdir, 1, 1)
    if (allfiles == None):
        print 'Error retrieving files from', scriptdir
        print '(Exiting.)'
        return None
    if len(allfiles) == 0:
        print 'No files found in', scriptdir
        print '(Exiting.)'
        return None
    for onefile in allfiles:
        if onefile[-3:] == '.py':
            pyfiles.append(onefile)
    return pyfiles
