#!/usr/bin/env python
##
#@package   Smakemenu
#@ingroup   other
#@ingroup   python
#@brief     make menu for shell
#@author    Tam Mayeshiba
#@date      8/3/11 - created
###
def main(scriptdir=""):
    """
    Purpose: makes menu from install directory
        inputs:  
            [$1] tscripts installation directory
            example: /home/user/bin/tscripts
        outputs:
    """
#   Modules:
    import os
    import sys
    import Xvaliddirectory
    import Smaketaglist
    import Xvalidletter
    import Xvalidinteger
    import Pgetseg
    import Sprompter
    import subprocess
#   Validation
#   #  scriptdir
    if (scriptdir == ""):
        scriptdir = os.path.join(os.environ["HOME"], 'bin/tscripts')
        print "Using script directory:", scriptdir
    scriptdir = Xvaliddirectory.main(scriptdir)
    if (scriptdir == None):
        print '(Exiting.)'
        return None
#   Make tag list so can work with that
    pyfiles=[]
    pyfiles = Smaketaglist.main(scriptdir)
    if (pyfiles == None):
        print 'Error making tag list.'
        print '(Exiting.)'
        return None
#   Print initial menu
    choice='0'
    myline=""
    myscript=""
    mytag=""
    useparamlist=[]
    param=""
    myprocess=""
    lenopts = len(pyfiles)
    pyline=""
    okay=""
    while (choice != 'q'):
        print 'Automatam Menu'
        while (choice not in ['q', 'Q']) or choice == None:
            for pyline in pyfiles:
                print pyline
            choice = raw_input('Select a number or Q to quit: ')
            if (choice not in ['q', 'Q']):
                choice = Xvalidinteger.main(choice, 1, lenopts)
                if (choice == None):
                    print 'Number must be between 1 and', lenopts
                else:
                    myline = pyfiles[choice-1]
                    myline = myline[4:] # remove leading numbers
                    myscript = Pgetseg.main(myline, 1, '.')
                    if (myscript == None):
                        print 'Error isolating script name.'
                        print '(Exiting.)'
                        return None
                    mytag = Pgetseg.main(myline, '.', ' ')
                    if (mytag == None):
                        print 'Error isolating tag name.'
                        print '(Exiting.)'
                        return None
                    print ""
                    #print ""
                    #print 'SCRIPT: ', myscript
                    #print 'TAG: ', mytag
                    print ""
                    useparamlist = Sprompter.main(scriptdir, myscript, mytag)
                    if (useparamlist == None):
                        print 'Error getting parameters.'
                        print '(Exiting.)'
                        return None
                    runstring = 'Uwrapper.py ' + myscript + '.' + mytag + ' '
                    for param in useparamlist:
                        runstring = runstring + str(param) + ' '
                    myprocess = subprocess.Popen([runstring], shell=True)
                    myprocess.wait()
                    print ""
                    okay = raw_input('Press Enter to return to the menu.')
            #print 'echo choice: ', choice
    print ""
    print 'Goodbye!'
    return True
