#!/usr/bin/env python
##
#@package   Smaketaglist
#@ingroup   other
#@ingroup   python
#@brief     gets python files and their tags, makes file
#@author    Tam Mayeshiba
#@date      8/3/11 - created
###
def main(scriptdir=""):
    """
    Purpose: gets python files and their tags
        inputs:  
            [$1] tscripts installation directory
            example:
        outputs:
            None if error
            True, and numbered file "S_TAGLIST"
    """
#   Modules:
    import os
    import sys
    import Xvaliddirectory
    import Sgetpyfiles
    import Sgettags
    import Xgrep
#   Validation
#   #  scriptdir
    if (scriptdir == ""):
        scriptdir = os.path.join(os.environ["HOME"], 'bin/tscripts')
        print "Using script directory:", scriptdir
    scriptdir = Xvaliddirectory.main(scriptdir)
    if (scriptdir == None):
        print '(Exiting.)'
        return None
#   Get python files
    pyfiles=[]
    mytags=[]
    onetag=""
    onefilebase=""
    taglist=[]
    desclist=[]
    descstr=""
    onestr=""
    tagstr=""
    tagcount=1
    countstr=""
    pyfiles = Sgetpyfiles.main(scriptdir)
    if (pyfiles == None):
        print 'Error retrieving files from', scriptdir
        print '(Exiting.)'
        return None
    if len(pyfiles) == 0:
        print 'No files found in', scriptdir
        print '(Exiting.)'
        return None
    for onefile in pyfiles:
        mytags = Sgettags.main(onefile)
        if (mytags == None):
            print 'Error with', onefile
        elif len(mytags) == 0:
            print 'No tags for', onefile
        else:
            onefilebase = os.path.basename(onefile)
            descstr = ""
            desclist = Xgrep.main(scriptdir, onefilebase, '@brief')
            for onestr in desclist:
                descstr = descstr + onestr
            descstr = descstr[7:]
            descstr = descstr.strip()
            descstr = descstr[0:55] # character limit
            descstr = descstr.strip()
            onefilebase = onefilebase[:-3]
            for onetag in mytags:
                if (onetag != 'prompt'):
                    tagstr = onefilebase + '.' + onetag
                    tagstr = tagstr.ljust(25)
                    countstr = str(tagcount)
                    countstr = countstr.rjust(3)
                    taglist.append(countstr + ' ' + tagstr + ' ' + descstr)
                    tagcount = tagcount + 1
#   write file
    tagfile = open(scriptdir + '/S_TAGLIST', 'wb')
    for onetag in taglist:
        tagfile.write(onetag + '\n')
    tagfile.close()
    return taglist
