#!/usr/bin/env python
##
#@package   Sprompter
#@ingroup   other
#@ingroup   python
#@brief     prompter for parameters
#@author    Tam Mayeshiba
#@date      8/3/11
###
def main(filepath, filename, tag='main'):
    """
    Purpose: prompter for parameters
        inputs:  
            [$1] file path
            example: /home/tam/
            [$2] python file name with or without .py
            example: Ascript
            [$3] tag for which to prompt
            example: main
        outputs:
            return list of tags in order
    """
#   Modules:
    import os
    import sys
    import Pgetline
    import Pgetseg
    import Xvaliddirectory
#   Validation
#   #  path
    filepath = Xvaliddirectory.main(filepath)
    if (filepath == None):
        print '(Exiting.)'
        return None
#   #  fullfile
    if (filename[-3:] != '.py'):
        filename = filename + '.py'
    fullfile = os.path.join(filepath, filename)
    if not os.path.isfile(fullfile):
        print fullfile, 'is not a file.'
        print '(Exiting.)'
        return None
#   # tag
    if type(tag) != str:
        print tag, 'should be a string.'
        print '(Exiting.)'
        return None
#   get definition line
    defline=""
    dirname=""
    basename=""
    dirname = os.path.dirname(fullfile)
    basename = os.path.basename(fullfile)
    defline = Pgetline.main(dirname, basename, 'def ' + tag, 'X', 0, 1)
    if (defline == None):
        print '(Exiting.)'
        return None
#   get list of parameters
    defshort=""
    fullparamlist=[]
    getright=0
    defline2=""
    linect=""
    splitdef=[]
    defline1=""
    lineint=0
    #print defline
    getright = defline.find(')')  # if no closing parenthesis, find next line
    if (getright == -1):
        splitdef = defline.split(':')
        linect = splitdef[1]
        defline1 = splitdef[0]
        lineint = int(linect) + 1
        defline2 = Pgetline.main(dirname, basename, '0', lineint, 1)
        if (defline2 == None):
            print 'Error getting parameter second line.'
            print '(Exiting.)'
            return None
        defline = defline1 + defline2
        print defline
    defshort = Pgetseg.main(defline, '(', ')')
    if (defshort == ""):
        return []
    fullparamlist = defshort.split(',')
#   get defaults if necessary, and strip extra characters
    fullparam=""
    param=""
    default=""
    defaultlist=[]
    paramlist=[]
    onesplit=[]
    for fullparam in fullparamlist:
        onesplit = fullparam.split('=')
        param = onesplit[0]
        param = param.strip()
        paramlist.append(param)
        if len(onesplit) > 1:
            default = onesplit[1]
            default = default.strip()
            defaultlist.append(default)
        else:
            defaultlist.append("")
    #print paramlist
    #print defaultlist
#   get responses
    response=""
    resplist=[]
    maxindex=0
    count=0
    defval=""
    maxindex = len(paramlist) - 1
    if paramlist==[]:
        return resplist
    print '~~~', tag, 'in', basename, '~~~'
    print ""
    while (count <= maxindex):
        param = paramlist[count]
        defval = defaultlist[count]
        if (defval == ""):
            response = raw_input(param + ': ')
        else:
            response = raw_input(param + ' (default ' + defval + '): ')
        if (response == ""):
            resplist.append(defval)
        else:
            resplist.append(response)
        count = count + 1
    return resplist
