#!/usr/bin/env python
##
#@package   UXdependencies
#@ingroup   other
#@ingroup   python
#@brief     find missing dependencies of, or scripts that depend on,
#           a python script
#@details   prompt-based
#@author    Tam Mayeshiba
#@date      11/23/10
#@date      12/17/10 name change
###
def mydoc():
    """
    Purpose: find missing dependencies of python scripts in a directory, or for
             a file
        inputs:  
        outputs:
            list of missing dependencies
        notes:
            as of 11/23/2010 this ONLY finds modules, not functions within them
            example: evaluate whether Pscript is found, but can't tell if
                        fun1, fun2, or fun3 in Pscript exist
    """
#   Modules:
import os
import sys
import Xdepdeep
import Xdepcheck
import Xloopdepcheck
import Xdeponcheck
#   
#   #
fname=""
fallmiss=""
dirname=""
verbose=""
switcher=""
quitme=""
returnval=""
retitem=""
print 'Dependency checker.'
while (quitme != 1):
    print '    D = list dependencies for a single file.'
    print '    M = list missing dependencies for a single file.'
    print '    L = list missing dependencies in a whole directory.'
    print '    P = list files that depend ON a file.'
    print '    Q = quit'
    switcher = raw_input('Enter letter: ')
    try:
        switcher = str(switcher)
    except (TypeError, ValueError):
        print 'Invalid response.'
        continue
    if len(switcher) <= 0:
        pass
    else:
        switcher = switcher[0]
        switcher = switcher.upper()
        if (switcher == 'Q'):
            quitme = 1
        elif (switcher == 'D'):
            fname = raw_input('    File name: ')
            if (fname[-3:] != '.py'):
                fname = fname + '.py'
            fallmiss = raw_input('    0 - just this file or 1 - ' + 
                    'its dependencies too 0/1: ')
            returnval = Xdepdeep.main(fname, fallmiss)
            if (returnval == None):
                pass
            elif (returnval == ()):
                print 'No dependencies.'
            else:
                if (len(returnval[0])>0):
                    print 'Modules: '
                    for retitem in returnval[0]:
                        print retitem
                if (len(returnval[1])>0):
                    print 'Functions: '
                    for retitem in returnval[1]:
                        print retitem
        elif (switcher == 'M'):
            fname = raw_input('    File name: ')
            if (fname[-3:] != '.py'):
                fname = fname + '.py'
            dirname = raw_input('    Directory for dependencies: ')
            dirname = os.path.normpath(dirname)
            if ('/' in fname):
                pass
            else:
                fname = dirname + '/' + fname
            fallmiss = raw_input('    0 - just this file or 1 - ' + 
                    'its dependencies too 0/1: ')
            returnval = Xdepcheck.main(fname, dirname, fallmiss)
            if (returnval == None):
                pass
            elif (returnval == []):
                print 'No missing dependencies.'
            else:
                if (len(returnval)>0):
                    print 'Missing modules: '
                    for retitem in returnval:
                        print retitem
        elif (switcher == 'L'): 
            dirname = raw_input('    Directory in which to check: ')
            dirname = os.path.normpath(dirname)
            verbose = raw_input('    0 - Print aggregate or 1 - ' + 
                                'Print results per file: ')
            returnval = Xloopdepcheck.main(dirname, verbose)
            if (returnval == None):
                pass
            elif (returnval == []):
                print 'No missing dependencies.'
            else:
                if (len(returnval)>0):
                    print 'Missing modules: '
                    for retitem in returnval:
                        print retitem
        elif (switcher == 'P'):
            fname = raw_input('    File name: ')
            if (fname[-3:] != '.py'):
                fname = fname + '.py'
            dirname = raw_input('    Directory for dependencies: ')
            dirname = os.path.normpath(dirname)
            if ('/' in fname):
                pass
            else:
                fname = dirname + '/' + fname
            returnval = Xdeponcheck.main(dirname, fname)
            if (returnval == None):
                pass
            elif (returnval == []):
                print 'No files depend on this file.'
            else:
                if (len(returnval)>0):
                    print 'The following files depend on this file: '
                    for retitem in returnval:
                        print retitem
        else:
            print 'Invalid response.'
        print ''
print 'Exiting.'
