#!/usr/bin/env python
##
#@package   vasp
#@ingroup   vasp
#@ingroup   python
#@brief     Parse bader ACF file
#@author    Tam Mayeshiba
#@date      4/4/13 
###
def main(mydir, startion=0, endion=0):
    """
    Purpose: Parse bader ACF file
        inputs:  
            [$1] directory
            [$2] ion to start parsing
            [$3] ion to end parsing
            example:
        outputs:
    """
#   Modules:
    import os
    import sys
    import Xvalidinteger
    import Xvaliddirectory
#   Validation
#   #  
    mydir = Xvaliddirectory.main(mydir)
    if mydir == None:
        return None
    startion = Xvalidinteger.main(startion,1,None)
    if startion == None:
        return None
    endion = Xvalidinteger.main(endion,1,None)
    if endion == None:
        return None
#   
    mypath = os.path.join(mydir, "ACF.dat")
    myacf = open(mypath, 'rb')
    mylines=myacf.readlines()
    myacf.close()
    myion=0
    headerstr=mydir + ": bader ACF.dat extract from " + str(startion) + " to " + str(endion)
    chargestr=": CHARGE: "
    volstr=": VOL: "
    mylist=[]
    for myline in mylines:
        mylist = myline.split()
        if mylist[0].isdigit():
            myion = int(mylist[0])
            if (myion >= startion) and (myion <= endion):
                chargestr = chargestr + mylist[4] + ","
                volstr = volstr + mylist[6] + ","
    return headerstr + chargestr + volstr



def loop(topdir, startion=0, endion=0):
    """
    Purpose: Parse bader ACF file
        inputs:  
            [$1] top directory
            [$2] ion to start parsing
            [$3] ion to end parsing
            example:
        outputs:
    """
#   Modules:
    import os
    import sys
    import Xgetdirs
    import Xvaliddirectory
    import Vbaderparser
#   Validation
    topdir = Xvaliddirectory.main(topdir)
    if topdir == None:
        return None
    dirlist = Xgetdirs.main(topdir)
    onereturn=""
    biglist=[]
    for onedir in dirlist:
        onereturn = Vbaderparser.main(onedir, startion, endion)
        if not (onereturn == None):
            biglist.append(onereturn)
    for listitem in biglist:
        print listitem
    return biglist

