#!/usr/bin/env python
##
#@package   Vcvf
#@ingroup   vasp
#@ingroup   python
#@brief     run cvf for all directories in a directory
#@author    Tam Mayeshiba
#@date      2/25/11 
###
def main(topdir, confeach=0):
    """
    Purpose: run cvf for all directories in a directory
        inputs:  
            [$1] top directory
            example: /home/tam/allNaClcopies
            [$2] ask for confirmation before each directory?
                0 - no (default)
                1 - yes
        outputs:
            None if error
            True when complete
        notes: this does exist as a single-line script
            only goes one level deep
    """
#   Modules:
    import os
    import sys
    import Xvaliddirectory
    import Xgetdirs
    import Xvalidinteger
    import Xvalidletter
    import subprocess
#   Validation
#   #  directory
    topdir = Xvaliddirectory.main(topdir)
    if (topdir == None):
        print '(Exiting.)'
        return None
#   #   confirmation
    confeach = Xvalidinteger.main(confeach, 0, 1)
    if (confeach == None):
        print '(Exiting.)'
        return None
#   #
    dirlist=[]
    dirlist = Xgetdirs.main(topdir, 1, 1)
    curdir=""
    curdir = os.getcwd()
    mydir=""
    runcmd=""
    response=""
    for mydir in dirlist:
        os.chdir(mydir)
        if (confeach == 1):
            response = raw_input('Okay to run cvf for ' + mydir + ' ? ')
            try:
                response = str(response)
            except (ValueError, TypeError):
                response = 'n'
            if len(response) == 0:
                response = 'n'
            response = response[0]
            response = Xvalidletter.main(response, ['y', 'n'], 1)
            if (response == None):
                response = 'n'
            if (response == 'y'):
                runcmd = subprocess.Popen('cvf', shell=True)
                runcmd.wait()
                print 'Done.'
            else:
                print 'Skipped.'
        else:
            print 'Cleaning', mydir, '.'
            runcmd = subprocess.Popen('cvf', shell=True)
            runcmd.wait()
            print 'Done.'
    return True
