#!/usr/bin/env python
##
#@package   Vdoscargap
#@ingroup   vasp
#@ingroup   python
#@brief     from Vdoscarmid, see if there is a bandgap
#@author    Tam Mayeshiba
#@date      1/21/11 
###
def main(existdir, ofile='DOSCAR'):
    """
    Purpose: get middle lines of DOSCAR, around Fermi energy
        inputs:  
            [$1] directory of run
            example: '/home/tam/NaCl'
            [$2] file name (default DOSCAR)
            example: 'DOSCARU'
        outputs:
            gap start, gap stop
            None if error
        notes:
            Currently this ONLY works for spin without specified RWIGS,
            so only columns 1, 2, and 3 are read in. 
    """
#   Modules:
    import os
    import sys
    import Xvaliddirectory
    import Vdoscarmid
    import pdb
#   Validation
#   #  directory
    existdir = Xvaliddirectory.main(existdir)
    if (existdir == None):
        print '(Exiting.)'
        return None
#   #   file
    fullfile=""
    fullfile = existdir + '/' + ofile
    if not os.path.isfile(fullfile):
        print fullfile, 'is not a valid file.'
        print '(Exiting.)'
        return None
#   get doscar midlist
    rawmid=[]
    rawmidln=""
    midsplit=[]
    dosflt=0
    energyflt=0
    startgap=False
    maxgapenergy=0
    mingapenergy=0
    returnminmax=[]
    rawmid = Vdoscarmid.main(existdir, ofile)
    if (rawmid == None):
        print 'Error obtaining middle values for', fullfile
        print '(Exiting.)'
        return None
    for rawmidln in rawmid:
        midsplit = rawmidln.split(':')
        energyflt = float(midsplit[0])
        dosflt = float(midsplit[1])
        if (dosflt < 0.00000001):
            if (startgap == False):
                startgap = True
                mingapenergy = energyflt
            else:
                continue
        else:
            if (startgap == False):
                continue
            else:
                maxgapenergy = energyflt
                break
    returnminmax.append(mingapenergy)
    returnminmax.append(maxgapenergy)
    return returnminmax
    
            
