#!/usr/bin/env python
##
#@package   Vgetmon
#@ingroup   vasp
#@ingroup   python
#@brief     gets return from last mon file and other information
#@author    Tam Mayeshiba
#@date      1/12/11 
#@date      3/2/11 sort mon files so find the correct one
###
def main(mydir):
    """
    Purpose: gets return from last mon file and other information
        inputs:  
            [$1] directory 
            example: '/home/tam/NaCl1'
        outputs:
            None - error
            String of finish information
    """
#   Modules:
    import os
    import sys
    import Pgetline
    import Pgetseg
    import glob
    import Xvaliddirectory
    #import pdb
#   validate directory
#   #
    mydir = Xvaliddirectory.main(mydir)
    if (mydir == None):
        print '(Exiting.)'
        return None
#   get total CPU time
    myline=""
    myseg=""
    monfile=""
    monsearch=[]
    monlen=0
    monsearch = glob.glob(mydir + '/' + 'mon*')
    monsearch.sort() #so mon files are chronological
    monlen = len(monsearch)
    #pdb.set_trace()
    if monlen < 1:
        print 'No monitor files detected in', mydir
        return None
    else:
        monfile = os.path.basename(monsearch[monlen - 1])
        if monlen > 1:
            print 'Warning: more than one monitor file detected in'
            print mydir
            print 'Using most recent file', monfile
    myline = Pgetline.main(mydir, monfile, 'Return:', 'X', 1)
    if (myline == None):
        print 'Error reading monitor file for', mydir
        print '(Exiting.)'
        return None
    myseg = Pgetseg.main(myline, 'Return:')
    if (myseg == None):
        print 'Error isolating return for', mydir
        print '(Exiting.)'
        return None
    return myseg
#
#
def loop(topdir):
    """
    Purpose: gets monitor file results for directory
        inputs:  
            [$1] top directory 
            example: '/home/tam/NaClcollection'
        outputs:
            None - error
            list of monitor file results for directory
    """
#   Modules
    import os
    import sys
    import Vgetmon
    import Xvaliddirectory
    import Xgetdirs
#   Validate directory
    topdir = Xvaliddirectory.main(topdir)
    if (topdir == None):
        print '(Exiting.)'
        return None
#   #   other validation will be handled by Vgetmon
    dirlist=[]
    dirlist = Xgetdirs.main(topdir, 1, 5)
    mydir=""
    resultlist=[]
    noresultlist=[]
    for mydir in dirlist:
        myresult = Vgetmon.main(mydir)
        if (myresult != None):
            resultlist.append(mydir + ': ' + str(myresult))
        else:
            noresultlist.append(mydir)
    print 'Monitor file results: '
    for myresult in resultlist:
        print myresult,
    #if len(noresultlist) > 0:
    #    print 'Errors: '
    #    for myresult in noresultlist:
    #        print myresult
    return resultlist
