#!/usr/bin/env python
##
#@package   Vgetsamefile 
#@ingroup   vasp
#@ingroup   python
#@brief     gets all of the same file, renamed to folder
#@author    Tam Mayeshiba
#@date      1/23/12
###
def main(topdir, fname, savedir):
    """
    Purpose: Get all of the same file, renamed to folder
        inputs:  
            [$1] top directory
            example: /home/tam/NaClcollection
            [$2] file name
            example: 'CONTCAR', '*sum.csv'
            [$3] full directory to which to save
            example: /home/tam/filerepository
        outputs:

    """
#   Modules:
    import os
    import sys
    import shutil
    import fnmatch
    import Xvaliddirectory
    import Xgetfiles
    #   
#   Validation
#   #   topdir
    topdir = Xvaliddirectory.main(topdir)
    if topdir == None:
        return None
#   #   fname
    fname = str(fname)
#   #   savedir
    savedir = Xvaliddirectory.main(savedir)
    if savedir == None:
        print 'Create the save directory first.'
        return None
#   #
    onefile=""
    onebase=""
    base1=""
    base2=""
    base3=""
    base4=""
    dir1=""
    dir2=""
    dir3=""
    filelist = Xgetfiles.main(topdir, 1, 5)
    for onefile in filelist:
        base1 = os.path.basename(onefile)
        dir1 = os.path.dirname(onefile)
        if fnmatch.fnmatch(base1, fname):
            print 'Match', onefile
            base2 = os.path.basename(dir1)
            dir2 = os.path.dirname(dir1)
            base3 = os.path.basename(dir2)
            dir3 = os.path.dirname(dir2)
            base4 = os.path.basename(dir3)
            newname = base4 + '_' + base3 + '_' + base2 + '_' + base1
            print 'Newname: ', newname
            try:
                shutil.copy(onefile, os.path.join(savedir,newname))
            except OSError:
                'Duplicate of', onefile, 'exists in', savedir
    return True
