#!/usr/bin/env python
##
#@package   Vgrepme
#@ingroup   other
#@ingroup   python
#@brief     grep last occurrence of a line and return directory
#@author    Tam Mayeshiba
#@date      2/7/12 created
###
def main(topdir, grepstr, filename, dirmatch=""):
    """
    Purpose:
        inputs:  
            [$1] top directory for looping
            example: /home/tam/NaCl
            [$2] phrase to grep, in single quotes
            example: 'volume of cell'
            [$3] filename
            [$4] directory  match
            example: '*_bulk_static'
        outputs:
    """
#   Modules:
    import os
    import sys
    import Xgetdirs
    import Xvaliddirectory
    import subprocess
    import fnmatch
#   
#   #  
    topdir = Xvaliddirectory.main(topdir)
    if topdir == None:
        return None
    dirlist=[]
    dirlist = Xgetdirs.main(topdir,1,5)
    if dirlist == None:
        print 'Empty directory list.'
        return None
    if len(dirlist) == 0:
        print 'No directories.'
        return None
    mydir=""
    fullpath=""
    result=""
    resultstr=""
    results=[]
    grepproc=""
    okay=0
    filelist=[]
    tryfile=""
    for mydir in dirlist:
        okay=0
        if not dirmatch == "":
            if fnmatch.fnmatch(mydir, dirmatch):
                okay = 1
            else: 
                okay = 0
        else:
            okay = 1
        if okay:
            filelist = os.listdir(mydir)
            for tryfile in filelist:
                if fnmatch.fnmatch(tryfile, filename):
                    fullpath = os.path.join(mydir, tryfile)
                    grepproc = subprocess.Popen('grep "' + grepstr + '" ' + fullpath + '| tail -n 1', shell=True, stdout = subprocess.PIPE)
                    grepproc.wait()
                    result = grepproc.communicate()
                    resultstr = fullpath + ':' + str(result)
                    results.append(resultstr)
    resultstr=""
    for resultstr in results:
        print resultstr
    return results
