#!/usr/bin/env python
##
#@package   Vjobstarted
#@ingroup   vasp
#@ingroup   python
#@brief     checks to see if VASP job has started
#@details   checks to see if OUTCAR file is present
#@author    Tam Mayeshiba
#@date      12/28/10 
###
def main(dirtocheck):
    """
    Purpose: checks to see if VASP job has started (OUTCAR file is present)
        inputs:  
            [$1] directory of run
            example: '/home/tam/NaCl'
        outputs:
            True - job has started running
            False - job has not yet run
            None - error
    """
#   Modules:
    import os
    import sys
    import Xvaliddirectory
#   validation
    dirtocheck = Xvaliddirectory.main(dirtocheck)
    if (dirtocheck == None):
        print '(Exiting.)'
        return None
#   #  
    if os.path.isfile(dirtocheck + '/OUTCAR'):
        return True
    return False
