#!/usr/bin/env python
##
#@package   Vjumpdirssilent
#@ingroup   vasp
#@ingroup   python
#@brief     jump in each of several nn directions, silent
#@author    Tam Mayeshiba
#@date      4/12/11 created 
#@date	    9/15/11 modify to use Vjumpdirsnew
###
def main():
    """
    Purpose: run Vjumpdirsnew in the background
        inputs:  
	    None. Run in directory with bulk ready to go and an input file where
	    vac2line is a period-delimited list of jumps to take.
        notes:
            having too many parameters makes this unusable with Uwrapper.py
    """
#   Modules:
    import os
    import sys
    import subprocess
    import Vjumpdirsnew
    import Xtimestring
    import Xuniquename
#   Validation will be handled by Vjumpdirsnew. 
#   run in background
#   #   set up output file
    filestr=""
    fileme=""
    curpath=""
    startname=""
    curpath = os.getcwd()
    startname = os.path.basename(curpath)
    filestr = 'monneb_' + startname + '_' + Xtimestring.main() + '_'
    filestr = Xuniquename.main(curpath, filestr, 'f', '', 1, 100)
    if (filestr == None):
        print 'Unique filename could not be created.'
        print '(Exiting.)'
        return None
    filestr = curpath + '/' + filestr
    fileme = open(filestr, 'ab')
    fileme = open(filestr, 'ab')
#   #   run process
    hidevmon=""
    hidevmon = subprocess.Popen(['Uwrapper.py', 'Vjumpdirsnew'],
            stdout=fileme, stderr=fileme)
    fileme.close()
    print hidevmon
    return True
