#!/usr/bin/env python
##
#@package   Vmodstatic
#@ingroup   vasp
#@ingroup   python
#@brief     modify a folder to be a static run with ISMEAR = -5
#@author    Tam Mayeshiba
#@date      5/18/11 copied from Vrunstatic
def main(staticdir):
    """
    Purpose:
        inputs:  
            [$1] folder with unmodified files for static run
            example: /home/tam/bulk/NaCl_static
        outputs:
            None - if error
            True - if modified successfully
    """
#   Modules:
    import os
    import sys
    import Xvaliddirectory
    import Pmultkpts
    import Pmodfilenew
#   Validation
#   #  directories
    staticdir = Xvaliddirectory.main(staticdir)
    if (staticdir == None):
        print '(Exiting.)'
        return None
#   modify files for static run
    modstat=""
    modstat = Pmodfilenew.main(staticdir, 'INCAR', 'IBRION', 'X', 'R',
                                'IBRION = -1')
    if (modstat == None):
        return None
    modstat = Pmodfilenew.main(staticdir, 'INCAR', 'NSW', 'X', 'R',
                                'NSW = 0')
    if (modstat == None):
        return None
    modstat = Pmodfilenew.main(staticdir, 'INCAR', 'PREC', 'X', 'R',
                                'PREC = Accurate')
    if (modstat == None):
        return None
    mynumkpts=0
    mynumkpts = Pmultkpts.main(staticdir)
    if (mynumkpts == None):
        return None
    if (mynumkpts > 8):
        modstat = Pmodfilenew.main(staticdir, 'INCAR', 'ISMEAR', 'X', 'R',
                                    'ISMEAR = -5')
        if (modstat == None):
            return None
    return True
