#!/usr/bin/env python
##
#@package   Vnelect
#@ingroup   vasp
#@ingroup   python
#@brief     calculate NELECT from POTCAR and POSCAR
#@author    Tam Mayeshiba
#@date      2/25/11 
###
def main(existdir):
    """
    Purpose:
        inputs:  
            [$1] directory of VASP files
            example: '/home/tam/NaCl'
        outputs:
            total number of electrons in system
            None if error
    """
#   Modules:
    import os
    import sys
    import Xvaliddirectory
    import Vnumatoms
    import Vzval
#   Validation
#   #  directory
    existdir = Xvaliddirectory.main(existdir)
    if (existdir == None):
        print '(Exiting.)'
        return None
#   #   get number of atoms
    numatomstr=""
    numatomstr = Vnumatoms.main(existdir)
    if (numatomstr == None):
        print 'Error getting number of atoms in system.'
        print '(Exiting.)'
        return None
    numatomstrsplit=[]
    totalnum=0
    numatomstrsplit = numatomstr.split(':')
    totalnum = numatomstrsplit[0]
    indivnumstr = numatomstrsplit[1]
    atomnumlist=[]
    atomnumlist = indivnumstr.split(',')
    numspecies=0
    numspecies = len(atomnumlist)
#   #   get valences from POTCAR
    valencelist=[]
    valencelist = Vzval.main(existdir)
    if (valencelist == None):
        print 'Error getting valences from POTCAR.'
        print '(Exiting.)'
        return None
    lenvallist=0
    lenvallist = len(valencelist)
    if lenvallist == 0:
        print 'Valence list is empty; comparison cannot be made.'
        print '(Exiting.)'
        return None
#   # multiply
    if lenvallist != numspecies:
        print 'Number of atomic species in POSCAR does not equal'
        print 'number of valence entries. Comparison cannot be made.'
        print '(Exiting.)'
        return None
    count=0
    onezval=0
    zvaltot=0
    for count in range(numspecies):
        try:
            onezval = float(atomnumlist[count]) * float(valencelist[count])
        except (ValueError, TypeError):
            print 'Error multiplying values.'
            print '(Exiting.)'
            return None
        zvaltot = zvaltot + onezval
    return zvaltot
        
