#!/usr/bin/env python
##
#@package   Vnumatoms
#@ingroup   vasp
#@ingroup   python
#@brief     count number of atoms from POSCAR
#@author    Tam Mayeshiba
#@date      2/25/11 
#@date      3/2/11 if no POSCAR is found, look in '/00' subdirectory
#           if it exists
###
def main(existdir, usefile='POSCAR'):
    """
    Purpose:
        inputs:  
            [$1] directory of VASP files
            example: /home/tam/NaCl
            [$2] file name to use - default 'POSCAR'
        outputs:
            number of atoms (summed): number 1, number 2, number 3, etc.
            None if error
        example:
            40:8,8,24
    """
#   Modules:
    import os
    import sys
    import Xvaliddirectory
    import Pgetline
    import pdb
#   Validation
#   #  directory
    existdir = Xvaliddirectory.main(existdir)
    if (existdir == None):
        print '(Exiting.)'
        return None
#   get appropriate line from POSCAR
    numline=""
    numlist=[]
    firstnum=0
    if (os.path.isfile(existdir + '/' + usefile) != True):
        existdir = existdir + '/00'
    numline = Pgetline.main(existdir, usefile, 0, 6)
    if (numline == None):
        return None
    numlist = numline.split() # split out by whitespace
#   #   handle both VASP 4 and VASP 5
    if len(numlist) == 0:
        print 'Error trying to find number of atoms.'
        print '(Exiting.)'
        return None
    try:
        firstnum = int(numlist[0])
    except (ValueError, TypeError):
        numline = Pgetline.main(existdir, usefile, 0, 7)
        if (numline == None):
            return None
        numlist = numline.split()
        if len(numlist) == 0:
            print 'Error trying to find number of atoms.'
            print '(Exiting.)'
            return None
        try:
            firstnum = int(numlist[0])
        except (ValueError, TypeError):
            print 'Error trying to find number of atoms.'
            print '(Exiting.)'
#   #   presumably what is left should be a list of numbers as strings
    listnum=""
    myint=0
    totalnum=0
    returnstr=""
    count=0
    for listnum in numlist:
        try:
            myint = int(listnum)
        except (ValueError, TypeError):
            print 'Error separating some number to add to number of atoms.'
            print '(Exiting.)'
            return None
        totalnum = totalnum + myint
        if (count == 0):
            returnstr = returnstr + listnum
        else:
            returnstr = returnstr + ',' + listnum
        count = count + 1
    return str(totalnum) + ':' + returnstr

