#!/usr/bin/env python
##
#@package   Vrename 
#@ingroup   vasp
#@ingroup   python
#@brief     renames files in a directory (from automatam running)
#@author    Tam Mayeshiba
#@date      2/2/11
###
def main(setdir, newroot, oldroot=""):
    """
    Purpose:
        inputs:  
            [$1] description 
            example:
        outputs:
    """
#   Modules:
    import os
    import sys
    import shutil
    import fnmatch
    import Xvaliddirectory
    import Xvalidletter
    import Xgetdirs
#   Validation
#   #  
    setdir = Xvaliddirectory.main(setdir)
    if setdir == None:
        return None
    if not newroot.isalnum():
        print newroot, 'should be alphanumeric.'
        return None
    print 'New root name: ',newroot
#
    dirlist=[]
    staticlist=[]
    dirlist = Xgetdirs.main(setdir, 1, 1)
   
    mydir=""
    mybasename=""
    mydirname=""

    for mydir in dirlist:
        if oldroot == "":
            mybasename = os.path.basename(mydir)
            mydirname = os.path.dirname(mydir)
            if 'rel' not in mybasename:
                oldroot = mybasename
        else:
            pass
    
    print oldroot, 'being used as old name.'
    
    okay=""
    okay = raw_input('Okay? Y/N: ')
    okay = Xvalidletter.main(okay, ['y','n'],1)
    
    useroot=""
    if not okay == 'y':
        useroot = raw_input('Type a different old basename, or enter to quit: ')
        if useroot == "":
            print 'Exiting.'
            return None
        else:
            oldroot = useroot

    print 'Old root: ', oldroot
    print 'New root: ', newroot
    newpath=""
    newbase=""
    oldnames=[]
    newnames=[]
    for mydir in dirlist:
        mybasename = os.path.basename(mydir)
        mydirname = os.path.dirname(mydir)
        if mybasename == oldroot:
            newbase = newroot + '_bulk'
        elif fnmatch.fnmatch(mybasename, oldroot + '_rel[0-9]'):
            newbase = newroot + '_bulk_r' + mybasename[len(mybasename)-1]
        elif fnmatch.fnmatch(mybasename, oldroot + '_rel[0-9]' + '_ep[1-2]') or fnmatch.fnmatch(mybasename, oldroot + '_rel[0-9]' + '_neb'):
            newbase = newroot + mybasename[-4:]
        elif fnmatch.fnmatch(mybasename, 
            oldroot + '_rel[0-9]' + '_ep[1-2]' + '_rel[0-9]'):
            newbase = newroot + mybasename[mybasename.find('_ep'):mybasename.find('_ep')+4] + '_r' + mybasename[len(mybasename)-1]
        elif fnmatch.fnmatch(mybasename, 
            oldroot + '_rel[0-9]' + '_ep[1-2]' + '_rel[0-9]' + '_static'):
            newbase = newroot + mybasename[mybasename.find('_ep'):mybasename.find('_ep')+4] + '_static'
        elif fnmatch.fnmatch(mybasename, 
            oldroot + '_ep[1-2]' + '_rel[0-9]' + '_static'):
            newbase = newroot + mybasename[mybasename.find('_ep'):mybasename.find('_ep')+4] + '_static'
        elif fnmatch.fnmatch(mybasename, 
            oldroot + '_ep[1-2]' + '_static'):
            newbase = newroot + mybasename[mybasename.find('_ep'):mybasename.find('_ep')+4] + '_static'
        elif fnmatch.fnmatch(mybasename, oldroot + '_rel[0-9]' + '_static'):
            newbase = newroot + '_bulk_static'
        elif fnmatch.fnmatch(mybasename, oldroot + '_rel[0-9]' + '_static_1'):
            newbase =  newroot + '_bulk_static'
        elif fnmatch.fnmatch(mybasename, oldroot + '_rel[0-9]' + '_neb_static'):
            newbase = newroot + '_neb_static'
        elif fnmatch.fnmatch(mybasename, oldroot + '_neb_static'):
            newbase = newroot + '_neb_static'
        elif fnmatch.fnmatch(mybasename, oldroot + '_neb'):
            newbase = newroot + '_neb'
        elif fnmatch.fnmatch(mybasename, oldroot + '_bulk'):
            newbase = newroot + '_bulk'
        elif fnmatch.fnmatch(mybasename, oldroot + '_bulk_r[0-9]'):
            newbase = newroot + '_bulk_r' + mybasename[len(mybasename)-1]
        elif fnmatch.fnmatch(mybasename, oldroot + '_bulk_rel[0-9]'):
            newbase = newroot + '_bulk_r' + mybasename[len(mybasename)-1]
        elif fnmatch.fnmatch(mybasename, oldroot + '_bulk_static'):
            newbase = newroot + '_bulk_static'
        elif fnmatch.fnmatch(mybasename, oldroot + '_ep[1-2]'):
            newbase = newroot + mybasename[mybasename.find('_ep'):mybasename.find('_ep')+4] 
        elif fnmatch.fnmatch(mybasename, oldroot + '_ep[1-2]' + '_r[0-9]'):
            newbase = newroot + mybasename[mybasename.find('_ep'):mybasename.find('_ep')+4] + '_r' + mybasename[len(mybasename)-1]
        elif fnmatch.fnmatch(mybasename, oldroot + '_ep[1-2]' + '_rel[0-9]'):
            newbase = newroot + mybasename[mybasename.find('_ep'):mybasename.find('_ep')+4] + '_r' + mybasename[len(mybasename)-1]
        else:
            newbase = mybasename
        oldnames.append(mybasename)
        newnames.append(newbase)
    
    lenall=0
    lenall = len(oldnames)
    if not (lenall == len(newnames)):
        print 'Number of old names does not match number of new names. Error.'
        return None
    
    ct=0
    while (ct < lenall):
        print 'OLD: ', oldnames[ct].ljust(30), ' NEW: ', newnames[ct]
        ct = ct + 1

    listokay=""
    listokay = raw_input('List is okay? Y/N: ')
    listokay = Xvalidletter.main(listokay, ['y','n'],1)
    
    if not listokay == 'y':
        print 'Exiting. No changes.'
        return None
    

    ct=0
    while (ct < lenall):
        shutil.move(os.path.join(setdir, oldnames[ct]), os.path.join(setdir,newnames[ct]))
        ct = ct + 1
    
    staticlist=[]
    if not os.path.exists(os.path.join(setdir, newroot + '_neb_static')):
        return True

    staticlist = Xgetdirs.main(os.path.join(setdir, newroot + '_neb_static'), 1,1)
    statct=""
    for mydir in staticlist:
        mybasename = os.path.basename(mydir)
        mydirname = os.path.dirname(mydir)
        if fnmatch.fnmatch(mybasename, 'static[0-9]'):
            statct = mybasename[len(mybasename)-1]
            newbase = statct.zfill(2) + 'static'
            print 'NEW: ',newbase
            shutil.move(mydir, os.path.join(mydirname, newbase))
    return True
