#!/usr/bin/env python
##
#@package   Vzval
#@ingroup   vasp
#@ingroup   python
#@brief     gets ZVAL for each atom type in POTCAR
#@author    Tam Mayeshiba
#@date      2/25/11 
###
def main(existdir):
    """
    Purpose: gets ZVAL for each atom type in POTCAR
        inputs:  
            [$1] directory for VASP files
            example: /home/tam/NaCl
        outputs:
            list of ZVAL entries, in order of appearance in POSCAR
            None if error
    """
#   Modules:
    import os
    import sys
    import Xvaliddirectory
    import subprocess
    import Pgetseg
#   Validation
#   #  directory
    existdir = Xvaliddirectory.main(existdir)
    if (existdir == None):
        print '(Exiting.)'
        return None
#   use grep
    getzval=""
    curdir=""
    curdir = os.getcwd()
    os.chdir(existdir)
    getzval = subprocess.Popen(['grep ZVAL POTCAR'], shell=True, 
                stdout=subprocess.PIPE)
    zvalstr=""
    zvalstr = getzval.communicate()[0]
    getzval.wait()
#   parse grep results
    zvalstrlist=[]
    zvalstrlist = zvalstr.split('\n')
    zvalstritem=""
    zvalseg=""
    zvallist=[]
    for zvalstritem in zvalstrlist:
        if (zvalstritem == ''):
            continue
        zvalseg = Pgetseg.main(zvalstritem, 'ZVAL', 'mass')
        if (zvalseg == None):
            print '(Error in some ZVAL segment - please check results.)'
            continue
        zvalseg = Pgetseg.main(zvalseg, '=', 0)
        if (zvalseg == None):
            print '(Error in some ZVAL segment - please check results.)'
            continue
        zvalseg = zvalseg.lstrip()
        zvalseg = zvalseg.rstrip()
        zvallist.append(zvalseg)
    os.chdir(curdir)
    return zvallist
