#!/usr/bin/env python
##
#@package   Xdepcheck
#@ingroup   other
#@ingroup   python
#@brief     find missing dependencies of a script
#@author    Tam Mayeshiba
#@date      11/23/10 
###
def main(existf, installdir, allmiss=0):
    """
    Purpose: find missing dependencies of a script
        inputs:  
            [$1] script name 
                example: 'Pscript'
            [$2] install directory for scripts
                example: '/home/tam/bin/tscripts'
            [$3] 0 - (default) only this file
                 1 - check to see if its dependencies are also missing dep.s
        outputs:
            list of missing dependencies
        notes:
            should be run in the same directory as the script is stored
            as of 11/23/2010 this ONLY finds modules, not functions within them
            example: evaluate whether Pscript is found, but can't tell if
                        fun1, fun2, or fun3 in Pscript exist
    """
#   Modules:
    import os
    import sys
    import imp
    import Xdepdeep
#   
#   #
    existdir=""
    existdir = os.path.dirname(existf)
    if (os.path.isfile(existf)) == False:
        print existf, 'does not exist.'
        if (os.path.exists(existdir)) == False:
            print existdir, 'is not a valid path.'
        print '(Exiting.)'
        return None
    if (os.path.exists(installdir)) == False:
        print installdir, 'is not a valid path.'
        print '(Exiting.)'
        return None
#   #   get dependencies
    deptuple=""
    deptuple = Xdepdeep.main(existf, allmiss)
    if (deptuple == None):
        print 'Error finding dependencies for', existf
        print '(Exiting.)'
        return None
#   #
    modfind=""
    nomodlist=[]
    mymodlist = deptuple[0]
    mymod=""
    for mymod in mymodlist:
        try:
            modfind = imp.find_module(mymod)
        except (ImportError):
            try:
                modfind = imp.find_module(mymod, [installdir])
            except (ImportError):
                nomodlist.append(mymod)
    #print nomodlist
    return nomodlist
