#!/usr/bin/env python
##
#@package   Xdepdeep
#@ingroup   other
#@ingroup   python
#@brief     find dependencies of a script, and deps. of its dependencies
#@author    Tam Mayeshiba
###
def main(existf, allmiss=0):
    """
    Purpose: find dependencies of a program, and deps. of its dependencies
        inputs:  
            [$1] file name (including path) 
            [$2] 0 (default) - only find surface dependencies
                 1 - find dependencies of dependencies, too
        outputs:
            tuple of dependencies([modules],[module:function])
        notes:
            all non-standard python modules should start with 
            a capital letter (Pscript1.py, Xscript2.py)
        functions:
            getsurf(existf)
    """
#   Modules:
    import os
    import sys
#   
#   #
#   #   #
    existdir=""
    existdir = os.path.dirname(existf)
    if (os.path.isfile(existf)) == False:
        print existf, 'does not exist.'
        if (os.path.exists(existdir)) == False:
            print existdir, 'is not a valid path.'
        print '(Exiting.)'
        return None
    existdir = os.path.normpath(existdir) # may break in Windows
    try:
        allmiss = int(allmiss)
    except (TypeError, ValueError):
        print 'Second parameter' ,allmiss, 'is invalid.'
        print main.__doc__
        print '(Exiting.)'
        return None
#   #   get first set
    mytuple=()
    mytuple = getsurf(existf)
    if (allmiss == 0):
        return mytuple
    #   find dependencies of dependencies
    moremodlist=[]
    morefunlist=[]
    moretuple=()
    moremod=""
    morefun=""
    depmodlist=[]
    depmod=""
    depmodlist = mytuple[0]
    fullmodlist = mytuple[0]
    fullfunlist = mytuple[1]
    for depmod in depmodlist:
        if len(depmod)>0:
            if depmod[0].isupper():
                moretuple = getsurf(existdir + '/' + depmod + '.py')
                if (moretuple == None):
                    continue
                if (moretuple == ()):
                    continue
                if (len(moretuple)<1):
                    continue
                moremodlist = moretuple[0]
                morefunlist = moretuple[1]
                for moremod in moremodlist:
                    if (moremod not in fullmodlist):
                        fullmodlist.append(moremod)
                for morefun in morefunlist:
                    if (morefun not in fullfunlist):
                        fullfunlist.append(morefun)
    return (fullmodlist, fullfunlist)
#   #   #
#   #   #
def getsurf(existf):
    """
    Purpose: find dependencies of a program
        inputs:  
            [$1] file name (including path)
        outputs:
            tuple of dependencies([modules],[module:function])
        notes:
            all non-standard python modules should start with 
            a capital letter (Pscript1.py, Xscript2.py)
    """
    import os
    import sys
#   #   #
    existdir=""
    existdir = os.path.dirname(existf)
    if (os.path.isfile(existf)) == False:
        print existf, 'does not exist.'
        if (os.path.exists(existdir)) == False:
            print existdir, 'is not a valid path.'
        print '(Exiting.)'
        return None
#   #   read all lines from a file
    modlist=[]
    funlist=[]
    readall=""
    readln=""
    frompcs=""
    modpcs=""
    funpcs=""
    funval=""
    openf=""
    openf = open(existf, 'rb')
    readall = openf.readlines()
    for readln in readall:
        readln = readln.lstrip() #remove whitespace
        readln = readln.rstrip()
        if len(readln)<=0:
            continue
#   #   #   skip commented lines
        if (readln[0] == '#'):
            continue
        if ('import' in readln):
            if (readln[0:5] == 'from '):
                frompcs = readln.split('import')
                modpcs = frompcs[0].split()
                modlist.append(modpcs[1])
                funpcs = frompcs[1].split(',')
                for funval in funpcs:
                    funval = funval.lstrip()
                    funval = funval.rstrip()
                    if (funval != '*'):
                        funlist.append(modpcs[1] + ':' + funval)
            elif (readln[0:7] == 'import '):
                modpcs = readln.split() # import MODULE
                modlist.append(modpcs[1])
    return (modlist, funlist) 
