#!/usr/bin/env python
##
#@package   Xdeponcheck
#@ingroup   other
#@ingroup   python
#@brief     find files which depend ON this file
#@details   works only for python scripts (looks at import statements)
#@author    Tam Mayeshiba
#@date      11/30/10 
###
def main(installdir, existf):
    """
    Purpose: find missing dependencies of python scripts in a directory
        inputs:  
            [$1] install directory for scripts
                example: '/home/tam/bin/tscripts'
            [$2] full file path, or file in install directory above
                example: 'Pscript.py'
        outputs:
            list of missing dependencies
        notes:
            as of 11/23/2010 this ONLY finds modules, not functions within them
            example: evaluate whether Pscript is found, but can't tell if
                        fun1, fun2, or fun3 in Pscript exist
    """
#   Modules:
    import os
    import sys
    import imp
    import Xdepdeep
#   
#   #
    if (os.path.exists(installdir)) == False:
        print installdir, 'is not a valid path.'
        print '(Exiting.)'
        return None
    installdir = os.path.normpath(installdir)
    if not (os.path.isfile(existf)):
        if not (os.path.isfile(installdir + '/' + existf)):
            print existf, 'is not a file.'
            print '(Exiting.)'
            return None
#   get all files in the directory
    shortname = os.path.basename(existf)
    if (shortname[-3:] == '.py'):
        shortname = shortname[0:-3]
    else:
        print shortname, 'is not a valid Python script.'
        print '(Exiting.)'
        return None
    onewalk=""
    mywalk=""
    filelist=[]
    mywalk = os.walk(installdir)
    dirname=""
    filename=""
    missmodlist=[]
    ftuple=()
    flist=[]
    fmod=""
    depon=0
    deponlist=[]
    for onewalk in mywalk:
        dirname = onewalk[0]
        for filename in onewalk[2]:
            if (filename[-3:] == '.py'):
                filelist.append(dirname + '/' + filename)
    for filename in filelist:
    #    print filename
        depon = 0
        ftuple = Xdepdeep.main(filename, 0)
        if (ftuple != None):
            flist = ftuple[0]
            for fmod in flist:
                if (shortname == fmod):
                    depon = 1
        if (depon == 1):
            deponlist.append(filename)
    return deponlist
