#!/usr/bin/env python
##
#@package   Xdeponloop
#@ingroup   other
#@ingroup   python
#@brief     check all dependencies for each script
#@note      only goes one level deep
#@author    Tam Mayeshiba
#@date      5/20/11 created
###
def main(scriptdir):
    """
    Purpose: check all dependencies for each script in directory
        inputs:  
            [$1] directory housing scripts
            example: /home/tam/myscripts
        outputs:
        notes: only goes one level deep
    """
#   Modules:
    import os
    import sys
    import Xdeponcheck
    import Xvaliddirectory
    import Xgetfiles
#   Validation
#   #  
    scriptdir = Xvaliddirectory.main(scriptdir)
    if (scriptdir == None):
        print '(Exiting.)'
        return None
#   get files
    filelist=[]
    filelist = Xgetfiles.main(scriptdir, 1, 1)
#   for each script, run dependency check
    myfile=""
    myname=""
    mydep=""
    mydeplist=[]
    biglist=[]
    biglist.append(scriptdir)
    for myfile in filelist:
        myname = os.path.basename(myfile)
        if (len(myname) > 0):
            if (myname[-3:] == '.py'): 
                biglist.append(myname)
                mydeplist = Xdeponcheck.main(scriptdir, myname)
                if (mydeplist == None):
                    pass
                else:
                    for mydep in mydeplist:
                        biglist.append('    ' + os.path.basename(mydep))
    for mydep in biglist:
        print mydep
    return True

