#!/usr/bin/env python
##
#@package   Xgetfiles
#@ingroup   vasp
#@ingroup   python
#@brief     walks through filetree, gets full path names for all files
#@author    Tam Mayeshiba
#@date      12/14/10 
#@date      1/5/11 Add min and max depth support
###
def main(rundir, mindepth=1, maxdepth=5):
    """
    Purpose: walks through filetree, gets full path names for all files
       inputs:  
            [$1] directory to check
                example: '/home/tam/NaCl1'
            [$2] minimum levels deep to search - default 1
            [$3] maximum levels deep to search - default 5
       outputs:
            list of files with full file path
            None - error
    """
#   Modules:
    import os
    import sys
    import time
    import Xvaliddirectory
    import Xvalidinteger
#   
#   validate
#   #   validate run directory
    rundir = Xvaliddirectory.main(rundir)
    if (rundir == None):
        print '(Exiting.)'
        return None
#   #   validate level depth
    mindepth = Xvalidinteger.main(mindepth, 0, None)
    if (mindepth == None):
        print '(Exiting.)'
        return None
    maxdepth = Xvalidinteger.main(maxdepth, mindepth, None)
    if (maxdepth == None):
        print '(Exiting.)'
        return None
    filetree=""
    diritem=""
    fileitem=""
    fullfile=""
    filelist=[]
    filetree = os.walk(rundir)
    for diritem in filetree:
        for fileitem in diritem[2]:
            fullfile = diritem[0] + '/' + fileitem
            filelist.append(fullfile)
    #for fullfile in filelist:
    #    print fullfile
#   #   sort and pare file list
    paredfilelist=[]
    numsep=0
    minnumsep=0
    maxnumsep=0
    numsep = rundir.count('/') # find base number of forward slashes
    minnumsep = numsep + mindepth
    maxnumsep = numsep + maxdepth
    onefile=""
    onenumsep=0
    for onefile in filelist:
        onenumsep = onefile.count('/')
        if (onenumsep >= minnumsep) and (onenumsep <= maxnumsep):
            paredfilelist.append(onefile)
    paredfilelist.sort()
    return paredfilelist
