#!/usr/bin/env python
##
#@package   Xgrep
#@ingroup   other
#@ingroup   python
#@brief     search file for occurrences, return lines
#@author    Tam Mayeshiba
#@date      5/25/11 created
#@date      9/6/11 add line number
###
def main(existdir, fname, searchfor, lineno=0):
    """
    Purpose: search file for occurrences of a string, return lines
        inputs:  
            [$1] directory of file
            example: /home/tam/NaCl
            [$2] file name
            example: OSZICAR
            [$3] string for which to search
            example: E0
            [$4] append line number
                 0 - no (default)
                 1 - yes
        outputs:
            None if error
            list of lines in the file, in order, containing search string
    """
#   Modules:
    import os
    import sys
    import Xvaliddirectory
    import Xvalidinteger
#   Validation
#   #  existdir
    existdir = Xvaliddirectory.main(existdir)
    if (existdir == None):
        print '(Exiting.)'
        return None
#   # fname
    fullfile=""
    try:
        fname = str(fname)
    except (ValueError, TypeError):
        print fname, 'should be a string.'
        print '(Exiting.)'
        return None
    fullfile = existdir + '/' + fname
    if not os.path.isfile(fullfile):
        print fullfile, 'does not exist.'
        print '(Exiting.)'
        return None
#   # searchfor
    try:
        searchfor = str(searchfor)
    except (ValueError, TypeError):
        print searchfor, 'should be a string.'
        print '(Exiting.)'
        return None
#   # lineno
    lineno = Xvalidinteger.main(lineno, 0, 1)
    if (lineno == None):
        print '(Exiting.)'
        return None
#
    readme=""
    readln=""
    linenum=0
    gotlist=[]
    readme = open(fullfile, 'rb')
    readln = readme.readline()
    linenum = 1
    while (readln):
        if searchfor in readln:
            if (lineno == 0):
                gotlist.append(readln)
            else: 
                gotlist.append(readln + ' : ' + str(linenum))
        readln = readme.readline()
        linenum = linenum + 1
    readme.close()
    return gotlist

