#!/usr/bin/env python
##
#@package   Xloopdepcheck
#@ingroup   other
#@ingroup   python
#@brief     find missing dependencies for scripts in a directory
#@author    Tam Mayeshiba
#@date      11/23/2010 
###
def main(installdir, verbose=0):
    """
    Purpose: find missing dependencies of python scripts in a directory
        inputs:  
            [$1] install directory for scripts
                example: '/home/tam/bin/tscripts'
            [$2] 0 - (default): quiet
                 1 : verbose: print list for each script
        outputs:
            list of missing dependencies
        notes:
            as of 11/23/2010 this ONLY finds modules, not functions within them
            example: evaluate whether Pscript is found, but can't tell if
                        fun1, fun2, or fun3 in Pscript exist
    """
#   Modules:
    import os
    import sys
    import imp
    import Xdepcheck
#   
#   #
    if (os.path.exists(installdir)) == False:
        print installdir, 'is not a valid path.'
        print '(Exiting.)'
        return None
    try:
        verbose = int(verbose)
    except (TypeError, ValueError):
        print verbose, 'should be 0 (print aggregate)'
        print 'or 1 (print for each file)'
        print '(Exiting.)'
        return None
#   get all files in the directory
    onewalk=""
    mywalk=""
    filelist=[]
    mywalk = os.walk(installdir)
    dirname=""
    filename=""
    missmodlist=[]
    fmisslist=[]
    fmissmod=""
    for onewalk in mywalk:
        dirname = onewalk[0]
        for filename in onewalk[2]:
            if (filename[-3:] == '.py'):
                filelist.append(dirname + '/' + filename)
    for filename in filelist:
    #    print filename
        fmisslist = Xdepcheck.main(filename, installdir)
        if verbose:
            print filename
            print fmisslist
        if (fmisslist != None):
            for fmissmod in fmisslist:
                if (fmissmod not in missmodlist):
                    missmodlist.append(fmissmod)
    return missmodlist
