#!/usr/bin/env python
##
#@package   ZZthreadtest 
#@ingroup   vasp/tscripts
#@ingroup   python
#@brief     run one calculation group with time checking; for silent subprocess
#@author    Tam Mayeshiba
#@date      12/6/11
###

import os
import shutil
import classes
import time
import pdb
import subprocess
import threading

# set up paths
myc=""
mycalcgroup=""
outputfile=""
calcgrouppath=""
myc = classes.control()
mycalcgroup = myc.setup()
if mycalcgroup == "" or mycalcgroup == None:
    print 'No successful calculation group.'
    sys.exit()

calcgrouppath = mycalcgroup.calcgroup_in['calcgroup_path']
mypath = os.path.join(calcgrouppath, mycalcgroup.calcgroup_in['calcgroup_name'])

if not os.path.exists(calcgrouppath):
    os.mkdir(calcgrouppath)
if not os.path.exists(mypath):
    os.mkdir(mypath)

os.chdir(mypath)

outputfile = mypath + '/output.txt'
myfile = open(outputfile,'ab')
myfile.write(time.asctime() + '\n')

#mycalcgroup.start_calcgroup()
def monitor(mycalcgroup):
    print "Start calculation."
    mycalcgroup.start_calcgroup()

    while not mycalcgroup.status in ['E','C']:
        time.sleep(15)
        mycalcgroup.update()
        print time.asctime(), '\n'
        print mycalcgroup.status
        if not mycalcgroup.bulkcalc == "":
            print mycalcgroup.bulkcalc.run
        if not mycalcgroup.ep1calc == "":
            print mycalcgroup.ep1calc.run
        if not mycalcgroup.ep2calc == "":
            print mycalcgroup.ep2calc.run
        if not mycalcgroup.nebcalc == "":
            print mycalcgroup.nebcalc.run
            print mycalcgroup.nebcalc.static_runs
        if mycalcgroup.status == 'E':
            print 'CALCGROUP ERRORED OUT.'
        else:
            print 'CALCGROUP FINISHED.'

thread = threading.Thread(target = monitor, args = [mycalcgroup])
thread.start()

#proc.wait()

myfile.close()

