#!/usr/bin/env python
##
#@package   control_calcgroup 
#@ingroup   vasp/tscripts
#@ingroup   python
#@brief     run one calculation group with time checking; for silent subprocess
#@author    Tam Mayeshiba
#@date      12/6/11
###

import os
import shutil
import classes
import time
import pdb
import subprocess

# set up paths
myc=""
mycalcgroup=""
outputfile=""
calcgrouppath=""
myc = classes.control()
mycalcgroup = myc.setup()
if mycalcgroup == "" or mycalcgroup == None:
    print 'No successful calculation group.'
    sys.exit()

calcgrouppath = mycalcgroup.calcgroup_in['calcgroup_path']
mypath = os.path.join(calcgrouppath, mycalcgroup.calcgroup_in['calcgroup_name'])

if not os.path.exists(calcgrouppath):
    os.mkdir(calcgrouppath)
if not os.path.exists(mypath):
    os.mkdir(mypath)

os.chdir(mypath)

mycalcgroup.calcgroup_in.print_to_file(os.path.join(os.getcwd(), 'inputfile_calcgroup'))
#TTM this is necessary in order to pass information to the silent script
mycalcgroup.calcgroup_in['incar'].to_file(os.path.join(mypath, 'INCAR_init'))
mycalcgroup.calcgroup_in['potcar'].to_file(os.path.join(mypath, 'POTCAR_init'))
mycalcgroup.calcgroup_in['poscar'].to_file(os.path.join(mypath, 'POSCAR_init'))
mycalcgroup.calcgroup_in['kpoints'].to_file(os.path.join(mypath, 'KPOINTS_init'))

newinput = classes.whole_input()
mycalcgroup.calcgroup_in.clone_to_new_input(newinput)

newinput['incar'] = os.path.join(mypath, 'INCAR_init')
newinput['potcar'] = os.path.join(mypath, 'POTCAR_init')
newinput['poscar'] = os.path.join(mypath, 'POSCAR_init')
newinput['kpoints'] = os.path.join(mypath, 'KPOINTS_init')

newinput.print_to_file(os.path.join(os.getcwd(), 'inputfile'))


outputfile = mypath + '/output.txt'
myfile = open(outputfile,'ab')
myfile.write(time.asctime() + '\n')

#mycalcgroup.start_calcgroup()
proc = subprocess.Popen(['control_calcgroup_commands.py'], shell=True, stdout=myfile)

#proc.wait()

myfile.close()

