#!/usr/bin/env python
##
#@package   control_calcgroup 
#@ingroup   vasp/tscripts
#@ingroup   python
#@brief     run one calculation group with time checking; for silent subprocess
#@author    Tam Mayeshiba
#@date      12/6/11
###

import os
import sys
import classes
import time

mycalcgroup = sys.argv[0]
myinput = classes.calcgroup_input()
myinput.set_values_from_file(os.path.join(os.getcwd(), 'inputfile'))
mycalcgroup = classes.neb_calcgroup(myinput)
mycalcgroup.start_calcgroup()

while not mycalcgroup.status in ['E','C']:
    time.sleep(15)
    mycalcgroup.update()
    print time.asctime(), '\n'
    print mycalcgroup.status
    if not mycalcgroup.bulkcalc == "":
        print mycalcgroup.bulkcalc.run
    if not mycalcgroup.ep1calc == "":
        print mycalcgroup.ep1calc.run
    if not mycalcgroup.ep2calc == "":
        print mycalcgroup.ep2calc.run
    if not mycalcgroup.nebcalc == "":
        print mycalcgroup.nebcalc.run
        print mycalcgroup.nebcalc.static_runs
    if mycalcgroup.status == 'E':
        print 'CALCGROUP ERRORED OUT.'
    else:
        print 'CALCGROUP FINISHED.'

#   
#   #  
