#!/usr/bin/env python
#neb run standard testing
#
# test order
#Run
#1.  no folders
#2.  existing neb set up, not run
#3.  existing setup, CONTCARS in all, unfinished
#4.  existing setup, images finished, no statics
#5.  images finished, statics exist, unfinished 
#6.  images finished, all statics finished

#Expected response
#1.  create folders, neb
#2.  run neb
#3.  archive outputs and CONTCARs, run neb
#4.  set up and run statics
#5.  archive outputs and run statics
#6.  do nothing


import os
import shutil
import classes
import time


tmp = os.path.expanduser("~/bin/tscripts/NEB_STANDARDS_3im/test_start_files/")
env = os.getenv('HOSTNAME')
env_name = env.split('.')[0] #korczak, bardeen, etc.
if env_name == 'korczak':
    inputfile = 'input_korczak'
else:
    inputfile = 'input_bardeen'

inputlist=[]

pathlist=[
'~/control_test/neb_3im/test_1',
'~/control_test/neb_3im/test_2',
'~/control_test/neb_3im/test_3',
'~/control_test/neb_3im/test_4',
'~/control_test/neb_3im/test_5',
'~/control_test/neb_3im/test_6'
]

#for short testing
#pathlist=['~/control_test/neb_1im/test_4']

neb_runs = []
testcount = 0
lenlist = len(pathlist)
inputlist=[]

while testcount < lenlist:
    print 'TEST', testcount + 1, 'STARTED.'
    inputlist.append(classes.calculation_input())
    inputlist[testcount].set_values_from_file(pathlist[testcount] + '/' + inputfile)
    inputlist[testcount]['calc_path'] = pathlist[testcount]
    inputlist[testcount]['calc_name'] = 'ts3_neb'
    
    neb_runs.append(classes.neb_calculation(inputlist[testcount], tmp+'ts1_ep1_static', tmp+'ts1_ep2_static'))
    neb_runs[testcount].start_calc()
    if neb_runs[testcount].run == []:
        print 'Not run.'
    else:
        while not neb_runs[testcount].status in ['E','C']:
            time.sleep(5)
            neb_runs[testcount].update()
    if neb_runs[testcount].status == 'E':
        print 'TEST', testcount + 1, 'ERRORED OUT'
    else:
        print 'TEST', testcount + 1, 'FINISHED.'
    testcount = testcount + 1

