#!/usr/bin/env python
#neb run standard testing
#
# test order
#Run
#1.  no folders
#2.  existing neb set up, not run
#3.  existing setup, CONTCARs in some but not all
#4.  existing setup, CONTCARS in all, unfinished
#5.  existing setup, images finished, no statics
#6.  images finished, statics exist, unfinished 
#7.  images finished, statics exist, some finished
#8.  images finished, all statics finished

#Expected response
#1.  create folders, neb
#2.  run neb
#3.  archive outputs and CONTCARs, run neb
#4.  archive outputs and CONTCARs, run neb
#5.  set up and run statics
#6.  archive outputs and run statics
#7.  archive outputs and run statics
#8.  do nothing


import os
import shutil
import classes
import time


tmp = os.path.expanduser("~/bin/tscripts/NEB_STANDARDS/test_start_files/")

inputlist=[]

neb_in = classes.calculation_input()   #changed
neb_in.run_in.incar = classes.file(tmp+'INCAR')
neb_in.run_in.kpoints = classes.file(tmp+'KPOINTS')
neb_in.run_in.potcar = classes.file(tmp+'POTCAR')
neb_in.run_in.script = classes.submit_script('run1','default',1,1,2000,3)
neb_in.path = "~/control_test/testneb"

neb_in.control_param = classes.control_parameters()
neb_in.static_incar = classes.file(tmp+'INCAR_STATIC')
neb_in.calc_name = 'myneb'

ep1_in = classes.run_input()
ep2_in = classes.run_input()
ep1_in.path = tmp + 'neb1_rel1_ep1_rel1_static'
ep2_in.path = tmp + 'neb1_rel1_ep2_rel1_static'

neb_in.ep1 = classes.run(ep1_in)
neb_in.ep2 = classes.run(ep2_in)

#neb_in.ep1.contcar = tmp + 'ep1st/CONTCAR'
#neb_in.ep2.contcar = tmp + 'ep2st/CONTCAR'
#neb_in.ep1.oszicar = tmp + 'ep1st/OSZICAR'
#neb_in.ep2.oszicar = tmp + 'ep2st/OSZICAR'




pathlist=[
'~/control_test/neb/test_1',
'~/control_test/neb/test_2',
'~/control_test/neb/test_3',
'~/control_test/neb/test_4',
'~/control_test/neb/test_5',
'~/control_test/neb/test_6',
'~/control_test/neb/test_7',
'~/control_test/neb/test_8'
]

neb_runs = []
testcount = 0
lenlist = len(pathlist)
inputlist=[]

while testcount < lenlist:
    print 'TEST', testcount + 1, 'STARTED.'
    newinput = classes.calculation_input()
    newinput = neb_in
    newinput.path = pathlist[testcount]
    inputlist.append(newinput)

    print tmp
    mycalc = classes.neb_calculation(inputlist[testcount])

    neb_runs.append(mycalc)
    neb_runs[testcount].start_calc()
    if neb_runs[testcount].run == []:
        print 'Not run.'
    else:
        print 'Calc path: ', neb_runs[testcount].calc_in.path
        while not neb_runs[testcount].status in ['E','C']:
            time.sleep(5)
            neb_runs[testcount].update()
    if neb_runs[testcount].status == 'E':
        print 'TEST', testcount + 1, 'ERRORED OUT'
    else:
        print 'TEST', testcount + 1, 'FINISHED.'
    testcount = testcount + 1

