#!/usr/bin/env python
# TTM run standards for testing

import os
import shutil
import classes
import time
import pdb



tmp = os.path.expanduser("~/control_test/run/test_start_files/")
env = os.getenv('HOSTNAME')
if 'msae' in env:
    env_name = env.split('.')[0] #korczak, bardeen, etc.
else:
    env_name = 'ranger'
inputlist=[]

pathlist=[
'~/control_test/run/test_1/runtest',
'~/control_test/run/test_2/runtest',
'~/control_test/run/test_3/runtest',
'~/control_test/run/test_4/runtest',
'~/control_test/run/test_5/runtest',
'~/control_test/run/test_6/runtest',
'~/control_test/run/test_7/runtest',
'~/control_test/run/test_8/runtest',
]

bulk_runs = []
testcount = 0
lenlist = len(pathlist)

startinput = classes.whole_input()
startinput.set_values_from_file(tmp + 'input')
startinput['location'] = env_name
if startinput['location'] == 'curie':
    startinput['execline'] = '/opt/mpiexec/bin/mpiexec -comm ib /home/$USER/bin/vasp5.2_parallelIB > vasp.out'

print 'RUN TESTING'
while testcount < lenlist:
    print 'TEST', testcount + 1, 'STARTED.'
    inputlist.append(classes.run_input())
    startinput.clone_to_new_input(inputlist[testcount])
    inputlist[testcount]['run_path'] = pathlist[testcount]
    #inputlist[testcount].print_to_screen()    
    bulk_runs.append(classes.run(inputlist[testcount]))
    bulk_runs[testcount].submit_to_queue()
    while not bulk_runs[testcount].status in ['E','C']:
        time.sleep(5)
        bulk_runs[testcount].update_status()
    if bulk_runs[testcount].status == 'E':
        print 'TEST', testcount + 1, 'ERRORED OUT'
    else:
        print 'TEST', testcount + 1, 'FINISHED.'
    testcount = testcount + 1
