#!/usr/bin/env python

import os
import shutil
import classes
import time

tmp = os.path.expanduser("~/control_test/nebtest/")

neb_in = classes.calculation_input()   #changed
neb_in.run_in.incar = classes.file(tmp+'INCAR')
neb_in.run_in.kpoints = classes.file(tmp+'KPOINTS')
neb_in.run_in.potcar = classes.file(tmp+'POTCAR')
neb_in.run_in.script = classes.submit_script('run1','default',1,1,2000,3)
neb_in.path = "~/control_test/testneb"

neb_in.control_param = classes.control_parameters()
neb_in.static_incar = classes.file(tmp+'INCAR_STATIC')
neb_in.calc_name = 'myneb'

ep1_in = classes.run_input()
ep2_in = classes.run_input()
ep1_in.path = tmp + 'ep1st'
ep2_in.path = tmp + 'ep2st'

neb_in.ep1 = classes.run(ep1_in)
neb_in.ep2 = classes.run(ep2_in)

neb_in.ep1.contcar = tmp + 'ep1st/CONTCAR'
neb_in.ep2.contcar = tmp + 'ep2st/CONTCAR'
neb_in.ep1.oszicar = tmp + 'ep1st/OSZICAR'
neb_in.ep2.oszicar = tmp + 'ep2st/OSZICAR'


neb_run = classes.neb_calculation(neb_in)


if neb_run.run == []:
    print 'Not run.'
else:    
    while not neb_run.completed:
        time.sleep(5)
        neb_run.update()

print "finished"
