// **************************************************
// PrintFindsym
// **************************************************
// This funtion prints out structural data in a format for findsys

using namespace std;
#include <iostream>
#include "PrintFindsym.h"

void PrintFindsym(const structure & str,double accuracy)
{
  cout.setf(ios::fixed,ios::floatfield);
  cout.precision(10);
  structure sstr=str;

  // Set scale to 1 so you don't need to rescale coordinates.
  sstr.ReScale(1.0);
  matrix<double> lat=sstr.GetLat();
  vector<int> num_each_type;
  num_each_type=sstr.GetNumEachType();
  int coord_flag=sstr.GetCoordFlag();
  matrix<double> cpos=sstr.GetCpos();
  matrix<double> dpos=sstr.GetDpos();
  vector<string> names=sstr.GetNames();

  // Print out data in Findsym format

  cout << sstr.GetTitle() << endl;
  cout << accuracy << "                               accuracy (0=highest=1e-6) " << endl;
  cout << "1                                         form lattice: (1=3 vectors) (2=lengths,angles) " << endl;

  for (int i=0;i<3;i++){
    cout << lat[i][0] << " " << lat[i][1] << " " << lat[i][2] << "    Bravais lattice" << endl;
  }
  cout << "1.0 0.0 0.0                   unit cell in function of lattice parameter" << endl;
  cout << "0.0 1.0 0.0                   unit cell in function of lattice parameter" << endl;
  cout << "0.0 0.0 1.0                   unit cell in function of lattice parameter" << endl;
  cout << sstr.GetNumAtoms() << "                             number of atoms in the primitive unit cell" << endl;
 
  for (int i=0;i<num_each_type.size();i++)
    for(int j=1;j<=num_each_type[i];j++) 
      cout <<  num_each_type[i] << " ";
  
  cout << endl;
  int num_atoms=cpos.size();
  for (int i=0;i<num_atoms;i++)
    //  if (coord_flag==0) 
    cout << " " << dpos[i][0] << " " << dpos[i][1] << " " << dpos[i][2] << endl;
    //  if (coord_flag==1) cout << " " << cpos[i][0] << " " << cpos[i][1] << " " << cpos[i][2] << endl;
}

// Stefano Curtarolo MIT 2002
