// rtparams object. 

using namespace std;
#include <iostream>
#include "rtparams.h"


void rtparams::free()
{
}

void rtparams::copy(const rtparams & b)
{
  resx=b.resx;
  resy=b.resy;
  viewdir=b.viewdir;
  viewdir_s=b.viewdir_s;
  updir=b.updir;
  updir_s=b.updir_s;
  zoom=b.zoom;
  aspectratio=b.aspectratio;
  antialiasing=b.antialiasing;
  raydepth=b.raydepth;
  center=b.center;
  center_guide=b.center_guide;
  center_s=b.center_s;
  background=b.background;
  lightcenter=b.lightcenter;
  lightrad=b.lightrad;
  lightcolor=b.lightcolor;
  sphtex_tex=b.sphtex_tex;
  sphtex_tex_def=sphtex_tex_def;
  sphtex_color=b.sphtex_color;
  sphtex_color_def=b.sphtex_color_def;
  sphtex_phong=b.sphtex_phong;
  sphtex_phong_def=b.sphtex_phong_def;
  sphtex_names=b.sphtex_names;
  sph_rad=b.sph_rad;
  sph_rad_def=b.sph_rad_def;
  shading=b.shading;
  outfile=b.outfile;
  sc=b.sc;
  sc_s=b.sc_s;
  calc_type=b.calc_type;
  input_files=b.input_files;
  first_set=b.first_set;
  insert_file=b.insert_file;
  rotation=b.rotation;
  // Plane variables 
  plane=b.plane;
  plane_s=b.plane_s;
  plane_center=b.plane_center;
  plane_center_def=b.plane_center_def;
  plane_center_s=b.plane_center_s;
  plane_normal=b.plane_normal; 
  plane_normal_def=b.plane_normal_def;
  plane_normal_s=b.plane_normal_s;
  plane_color=b.plane_color;
  plane_color_def=b.plane_color_def;
  plane_color_s=b.plane_color_s;
  planetex_tex=b.planetex_tex;
  planetex_tex_def=b.planetex_tex_def;
  planetex_tex_s=b.planetex_tex_s;
}

// Constructors
rtparams::rtparams()
{
  calc_type = 0;
  resx=600;
  resy=600;
  viewdir = vector<double> (3,0.0);
  viewdir[1]=1;
  viewdir_s = 0;
  updir = vector<double> (3,0.0);
  updir[2]=1;
  updir_s=0;
  zoom=1;
  aspectratio=1;
  antialiasing=0;
  raydepth=12;
  center = vector<double> (3,0.0);
  center_guide = vector<double> (6,0.0);
  center_s = 0;
  background = vector<double> (3,1.0);
  lightcenter = matrix<double> (1,center);
  lightrad = vector<double> (1,0.001);
  vector<double> color (3,0.0);
  lightcolor = matrix<double> (1,color);
  sphtex_tex_def = vector<double> (4);
  sphtex_tex_def[0] = 0.3; // ambient
  sphtex_tex_def[1] = 0.6; // diffuse
  sphtex_tex_def[2] = 0.2; // specular
  sphtex_tex_def[3] = 1.0; // opacity
  sphtex_color_def = vector<double> (3,0.5);
  sphtex_phong_def = vector<double> (2,0.0);
  sphtex_phong_def[1] = 10000;
  sph_rad_def = 1;
  shading = "fullshade";
  outfile = "POSCAR_RT";
  sc=matrix<double> (3,3,0.0);
  sc[0][0]=1;
  sc[1][1]=1;
  sc[2][2]=1;
  sc_s=0;
  first_set=1;
  insert_file="NO_INSERT_FILE";
  rotation = vector<double> (6,0.0);
  struct_origin = vector<double> (3,0.0);
  int struct_origin_s=0;
  // Plane variables 
  plane=0;
  plane_s=0;
  plane_center = vector<double> (3);
  plane_normal = vector<double> (3);
  plane_color = vector<double> (3);
  planetex_tex = vector<double> (4);
  plane_center_def = vector<double> (3);
  plane_normal_def = vector<double> (3);
  plane_color_def = vector<double> (3);
  planetex_tex_def = vector<double> (4);
  plane_center_s=0;
  plane_normal_s=0;
  plane_color_s=0;
  planetex_tex_s=0;
}
  
rtparams::rtparams(const rtparams & b) {copy(b);}

const rtparams & rtparams::operator=(const rtparams & b)
{
  if (this != &b){
    free();
    copy(b);
  }
  return *this;
}
 
void rtparams::Print() const
{
  cout << "CENTER = " << center_guide[0] << " " << center_guide[1] << " " << center_guide[2] << " " << center_guide[3] << " " << center_guide[4] << " " << center_guide[5] << endl;
  cout << "VIEWDIR = " << viewdir[0] << " " << viewdir[1] << " " << viewdir[2] << endl;
  cout << "UPDIR = " << updir[0] << " " << updir[1] << " " << updir[2] << endl;
  cout << "STRUCTURE_ORIGIN = " << struct_origin[0] << " " << struct_origin[1] << " " << struct_origin[2] << endl;
  cout << "ROTATION = " << rotation[0] << " " << rotation[1] 
       << " " << rotation[2] << " " << rotation[3] 
       << " " << rotation[4] << " " << rotation[5] << endl;
}








