#ifndef EwaldFuncs_comp
#define EwaldFuncs_comp

#include <iostream>
#include <sstream>
#include <fstream>
#include <vector>
#include "structure.h"
#include "matrix.h"
#include "typedefs.h"

void Ewald(const structure & in_str, double & epoint, 
	   double & ereal, double & erecip, double & eewald,
	   double & eta, const double & SUMTOL);
double GetEta(const int & natoms,const double & vol);
double GetPointEner(const double & rteta, const vector<double> & atchg, 
		    const double & vol);
double GetRecipEner(const double & eta, const vector<double> & atchg,
		    const double & vol,
		    const matrix<double> & rlat, 
		    const matrix<double> & dpos,
		    const double & SUMTOL);
double GetRealEner(const double & eta, const vector<double> & atchg,
		   const double & vol,
		   const matrix<double> & lat, 
 		   const matrix<double> & dpos,
		   const double & SUMTOL);
double GetScreenedESEner();
void PrintEwald(const structure & in_str, double & epoint, 
		double & ereal, double & erecip, double & eewald,
		double & eta, const double & SUMTOL, ostream & outf);
double ScreenedESEner(const structure & in_str, const double & Ks, 
			 const double & SUMTOL);

#endif







