// **************************************************
// PrintClat
// **************************************************
//  This funtion prints out 3 lattice vectors in cartesian coordinates.

using namespace std;
#include <cmath>
#include <string>
#include <iostream>
#include <vector>
#include "UsefulFuncs.h"
#include "PrintClat.h"
#include "constants.h"

void PrintClat(char** argv)
{
  cout.setf(ios::fixed,ios::floatfield);
  cout.precision(10);
  vector<double> abc_angles(6,0.0);
  abc_angles[0] = atof(argv[2]);
  abc_angles[1] = atof(argv[3]);
  abc_angles[2] = atof(argv[4]);
  abc_angles[3] = atof(argv[5]);
  abc_angles[4] = atof(argv[6]);
  abc_angles[5] = atof(argv[7]);
  // Convert to radians since input is expected in degrees.
  abc_angles[3] = abc_angles[3] *TWOPI/360.0;
  abc_angles[4] = abc_angles[4] *TWOPI/360.0;
  abc_angles[5] = abc_angles[5] *TWOPI/360.0;
  matrix<double> clat = GetClat(abc_angles);
  for (int i=0;i<3;i++){
    cout << clat[i][0] << " " << clat[i][1] << " " << clat[i][2] << endl;
  }
}










