// **************************************************
// PrintImages
// **************************************************
//  This function prints out all the image files.
// TTM 1/25/12 adding more inputs
using namespace std;
#include <cmath>
#include <string>
#include <iostream>
#include <sstream>
#include <iomanip>
#include <fstream>
#include <vector>
#include "UsefulFuncs.h"
#include "PrintImages.h"

void PrintImages(structure strA, structure strB, const int & ni, 
		 const string & path_flag, const double & displacex,
         const double & displacey, const double & displacez,
         const int & which_atom)
{  
  /* Get cm of strA. Get image at i/(n-1) between
     the A and B.  Set mom1 of image to be that of strA.  
     Output that image as image i. */
  vector<double> mom1A=strA.GetMom1();
  for (int im=0;im<ni+2;im++){
    double f;
    if ((ni+2)>1){
      f=(double)im/double(ni+1);
    }
    else{
      f=0;
    }
    structure imstr; //TTM 1/25/12 initialize out here
    if (im>0 && im<ni+1){//TTM 1/25/12 add on more flags if not an endpoint image
      imstr=GetIntpolStr(strA,strB,f,path_flag, displacex, displacey, displacez, which_atom);
    }
    else {
      imstr=GetIntpolStr(strA,strB,f,path_flag,0,0,0,0);
    }
    imstr.SetMom1(mom1A);
    // Set title to include image name.
    ostringstream titlestream;
    if (im<10) {
      titlestream << "POSCAR_0" << im << ":" << imstr.GetTitle() << ends;
    }
    else{
      titlestream << "POSCAR_" << im << ":" << imstr.GetTitle() << ends;
    }
    imstr.SetTitle(titlestream.str().c_str());
    // Set output file name.
    ostringstream namestream;
    if (im<10) {
     namestream << "POSCAR_0" << im << ends;
    }
    else{
      namestream << "POSCAR_" << im << ends;
    }
/*    char* namechar = namestream.str().c_str();
      ofstream outfile(namechar);*/
    ofstream outfile( namestream.str().c_str());
    outfile << imstr;
    // Create directory
    ostringstream mkdirstream;
    if (im<10) {
      mkdirstream << "mkdir 0" << im << ends;
    }
    else{
      mkdirstream << "mkdir " << im << ends;
    }
/*    char* mkdirchar = mkdirstream.str().c_str();
    system(mkdirchar);*/
    system(mkdirstream.str().c_str());
    // Copy POSCAR into directory
    ostringstream cpcmdstream;
    if (im<10) {
//      cpcmdstream << "cp " << namechar << " " << "0" << im << "/POSCAR" << ends;
      cpcmdstream << "cp " << namestream.str().c_str() << " " << "0" << im << "/POSCAR" << ends;
    }
    else{
//      cpcmdstream << "cp " << namechar << " " << im << "/POSCAR" << ends;
      cpcmdstream << "cp " << namestream.str().c_str() << " " << im << "/POSCAR" << ends;
    }
/*    char* cpcmdchar = cpcmdstream.str().c_str();
    system(cpcmdchar);*/
    system(cpcmdstream.str().c_str());
  }
} // end routine








