#ifndef rtparams_comp
#define rtparams_comp

#include <vector>
#include <string>
#include "matrix.h"
#include "typedefs.h"

class rtparams
{
public:
  void free();
  void copy(const rtparams & b);
  // Constructors
  rtparams(); // default
  rtparams(const rtparams & b); // default
  //Operators
  const rtparams & operator=(const rtparams & b);
  // Accessors
  void Print() const;
  // variables
  double resx;
  double resy;
  vector<double> viewdir;
  int viewdir_s;
  vector<double> updir;
  int updir_s;
  double zoom;
  double aspectratio;
  double antialiasing;
  double raydepth;
  vector<double> center;
  vector<double> center_guide;
  int center_s;
  vector<double> background;
  matrix<double> lightcenter;
  vector<double> lightrad;
  matrix<double> lightcolor;
  // Sphere texture variables (ambient, diffuse, specular, opacity)
  matrix<double> sphtex_tex;
  vector<double> sphtex_tex_def;
  matrix<double> sphtex_color;
  vector<double> sphtex_color_def;
  matrix<double> sphtex_phong;
  vector<double> sphtex_phong_def;
  vector<string> sphtex_names;
  vector<double> sph_rad;
  // Plane variables 
  int plane;
  int plane_s;
  vector<double> plane_center;
  vector<double> plane_normal; 
  vector<double> plane_color;
  vector<double> planetex_tex;
  vector<double> plane_center_def;
  vector<double> plane_normal_def; 
  vector<double> plane_color_def;
  vector<double> planetex_tex_def;
  int plane_center_s;
  int plane_normal_s;
  int plane_color_s;
  int planetex_tex_s;
  double sph_rad_def;
  string shading;
  string outfile;
  matrix<double> sc;
  int sc_s;
  int calc_type;
  vector<string> input_files;
  int first_set;
  string insert_file;
  vector<double> rotation;
  vector<double> struct_origin;
  int struct_origin_s;
};

#endif





