// **************************************************
// PrintNData
// **************************************************
//  This funtion prints out structural data.

using namespace std;
#include <cmath>
#include <iostream>
#include "UsefulFuncs.h"
#include "PrintNData.h"

#include<cstdio>
extern double angle_deg(const double&,const double&,const double&,const double&,const double&,const double&);
extern double lenght(const double&,const double&,const double&);


void PrintNdata(const structure & str)
{
  cout.setf(ios::fixed,ios::floatfield);
  cout.precision(10);
  structure sstr=str;
  
  // Set scale to 1 so you don't need to rescale coordinates.
  sstr.ReScale(1.0);
  matrix<double> lat=sstr.GetLat();
  vector<int> num_each_type;
  num_each_type=sstr.GetNumEachType();
  int coord_flag=sstr.GetCoordFlag();
  matrix<double> cpos=sstr.GetCpos();
  matrix<double> dpos=sstr.GetDpos();
  vector<string> names=sstr.GetNames();
  int i,j,k;

  // Print out data in Platon format

  double volume=
    lat[0][0]*lat[1][1]*lat[2][2]+
    lat[1][0]*lat[2][1]*lat[0][2]+
    lat[0][1]*lat[1][2]*lat[2][0]-
    lat[0][2]*lat[1][1]*lat[2][0]-
    lat[0][1]*lat[1][0]*lat[2][2]-
    lat[0][0]*lat[1][2]*lat[2][1];
  double normalization=pow(volume,0.333333333333333333333);

  printf(" %6.5f %6.5f %6.5f %6.5f %6.5f %6.5f \n",
         lenght(lat[0][0],lat[0][1],lat[0][2])/normalization,
         lenght(lat[1][0],lat[1][1],lat[1][2])/normalization,
         lenght(lat[2][0],lat[2][1],lat[2][2])/normalization,
         angle_deg(lat[1][0],lat[1][1],lat[1][2],lat[2][0],lat[2][1],lat[2][2]),
         angle_deg(lat[0][0],lat[0][1],lat[0][2],lat[2][0],lat[2][1],lat[2][2]),
         angle_deg(lat[0][0],lat[0][1],lat[0][2],lat[1][0],lat[1][1],lat[1][2]));//,volume);
 
  // cout << sstr.GetNumAtoms() << endl;
  /* 
     k=0;
     for (i=0;i<num_each_type.size();i++)
     for(j=1;j<=num_each_type[i];j++) {
     printf("%c%i ",i+66,j);
     printf("%6.5f %6.5f %6.5f \n",dpos[k][0],dpos[k][1],dpos[k][2]);
     k++;
     }
  */
}

// Stefano Curtarolo
