/*
 *  potalign.h
 *  
 *
 *  Created by Brian Puchala on 3/30/10.
 *  All rights reserved.
 *
 */

#include<iostream>
#include<fstream>
#include<istream>
#include<cstdlib>
#include<cstring>
#include<cmath>
#include<vector>
#include<stdlib.h>
#include<stdio.h>
#include<iomanip>
#include<time.h>
#include<sstream>

using namespace std;
void potalign(string, string, string);


/*int main(int argc, char *argv[])
{
	if( argc != 4)
	{
		cout << "error,  call using:  potalign potalign_input.txt OUTCAR CONTCAR" << endl;
		exit(1);
	}
	
	string inputfile = argv[1]; //"potalign_input.txt"
	string outcar = argv[2]; // "OUTCAR";
	string poscar = argv[3]; // "CONTCAR";
	potalign(inputfile,outcar,poscar);

	return 0;
}*/

void potalign(string in, string out, string pos)
{

	string inputfile = in; //"potalign_input.txt"
        string outcar = out; // "OUTCAR";
        string poscar = pos; // "CONTCAR";

	string tmp_str, tmp_str2;
	int i,j,k;
	char tmp_char[255];
	float scl, tmp_f;
	float lat_vectors[3][3];
	size_t s;
	ifstream infile0;
	ifstream infile;
	ifstream infile2;
	ifstream infile3;
	int range;	// set by user
	vector<string> atom_types;	//read from OUTCAR
	vector<int> num_atoms;	// # of atoms of each type
	vector<int> cum_num_atoms;	// # of atoms of each type
	vector<double> atom_def_r;
	vector< vector<double> > atom_pos;	//position of atoms in direct coordinates
	vector<int> atom_type;				//type of atoms
	vector<double> atom_pot;			//electrostatic potential of atoms
	vector<double> atom_pot_shift;		//defect - perfect
	int num_atom_types;
	int num_defects;
	vector<string> host_types;			//set by user
	vector<double> host_perf_pot;		//set by user
	istringstream ss(istringstream::in);
	
	
	/// ////////////////////////////
	// read defect position, host atom types and host atom reference electrostatic potential from 'inputfile'
	
	infile0.open(inputfile.c_str());
	if(!infile)
	{
		cout << "error: cannot open " << inputfile << endl;
		exit(1);
	}
	
	// get number of defects from first line
	getline( infile0, tmp_str);
	s = tmp_str.find("//"); if( s == 0) s = 1;
	tmp_str = tmp_str.substr(0,s-1);
	tmp_str.append("\0");
	ss.clear();
	ss.str(tmp_str);
	ss >> num_defects;
	cout << "# defects: " << num_defects;
	double defect_pos[num_defects][3];				//position of defect in direct coordinates, set by user
	
	
	
	// get defect position from first line
	for(i=0;i<num_defects;i++)
	{
	getline( infile0, tmp_str);
	s = tmp_str.find("//"); if( s == 0) s = 1;
	tmp_str = tmp_str.substr(0,s-1);
	tmp_str.append("\0");
	ss.clear();
	ss.str(tmp_str);
	ss >> defect_pos[i][0] >> defect_pos[i][1] >> defect_pos[i][2];
	cout << "Defect position in Direct Coordinates: " << defect_pos[i][0] << " " << defect_pos[i][1] << " " << defect_pos[i][2] << endl;
	}
	
	// get range from second line
	getline( infile0, tmp_str);
	s = tmp_str.find("//"); if( s == 0) s = 1;
	tmp_str = tmp_str.substr(0,s-1);
	tmp_str.append("\0");
	ss.clear();
	ss.str(tmp_str);
	ss >> range;
	cout << "Range == " << range << endl;
	if( range == 0 || range < -1)
	{
		cout << "error: set range to a positive integer or -1 to use all atoms" << endl;
		exit(1);
	}

	
	while( infile0.eof() == false)
	{
		tmp_str2 = " ";
		tmp_f = 0.0;
		getline( infile0, tmp_str);
		s = tmp_str.find("//"); 
		if( s == 0) s = 1;
		tmp_str = tmp_str.substr(0,s-1);
		tmp_str.append("\0");
		ss.clear();
		ss.str(tmp_str);
		ss >> tmp_str2 >> tmp_f;
		if( tmp_str2 != " " )
		{
			host_types.push_back(tmp_str2);
			host_perf_pot.push_back(tmp_f);
		
			cout << "Host atoms: " << tmp_str2 << "  Host perfect potential: " << tmp_f << endl;
		}
	}
	
	
		
	/// ////////////////////////////
	// get atom_types from outcar
	infile.open(outcar.c_str());
	if( !infile)
	{
		cout << "no " << outcar << " here." << endl;
	}
	
	num_atom_types = 0;
	int num_electrostatic = 0;
	while( getline(infile,tmp_str))
	{
		//cout << tmp_str << endl;
		if( tmp_str.find("electrostatic")!=string::npos)
		{
			num_electrostatic++;
		}
	
		if( tmp_str.find("TITEL")!=string::npos)
		{
			istringstream ss (tmp_str,istringstream::in);
			
			for( i=0;i<4;i++)
				ss >> tmp_str2;
			
			atom_types.push_back(tmp_str2);
			
			cout <<  tmp_str << "| atom_type[" << num_atom_types << "] = " << atom_types[num_atom_types] << endl;
		
			num_atom_types++;
		}
			
	}
	int tot_num_electrostatic = num_electrostatic;
	
	infile.close();
	/// ////////////////////////////
	
	// open CONTCAR
	infile2.open(poscar.c_str());
	if( !infile2)
	{
		cout << "no " << poscar << " here." << endl;
	}

	getline( infile2, tmp_str);
	//cout << tmp_str << endl;
	{
		getline( infile2, tmp_str);
		istringstream ss (tmp_str,istringstream::in);
		ss >> scl;
		cout << 1.0 << endl;
	}
	// get supercell vectors
	for(i=0;i<3;i++)
	{
		getline( infile2, tmp_str);
		//cout << tmp_str << endl;
		istringstream ss (tmp_str,istringstream::in);
		for(j=0;j<3;j++)
		{
			ss >> lat_vectors[i][j];
			lat_vectors[i][j] *= scl;
			cout << lat_vectors[i][j] << " ";
		}
		cout << endl;
	}
	
	scl = 1.0;
	
	getline( infile2, tmp_str);
	
	int sum_num_atoms = 0;
	int num;
	{
		istringstream ss (tmp_str,istringstream::in);
			
		// get num_atoms
		while(ss.good())
		{
			ss >> num;
			num_atoms.push_back(num);
			sum_num_atoms += num;
			cum_num_atoms.push_back( sum_num_atoms);	
			cout << num << " " ;
		}
	}
	cout << endl;
	
	bool direct = true;
	// get Direct / Cartesian (assume Direct for now)
	getline( infile2, tmp_str);
	cout << tmp_str << endl;
	{
		/*
		size_t found = tmp_str.find_first_of("dDcC");
		cout << " first of dDcC: " << tmp_str.at( found) << "  found: " << found << endl;
		
		if( tmp_str.at(found) == 'd' || tmp_str.at(found) == 'D')
			direct = true;
		else if( tmp_str.at(found) == 'c' || tmp_str.at(found) == 'C')
			direct = false;
		else
		{	cout << "error: direct (d/D) or cartesian (c/C) not found" << endl;
			infile2.close();
			return 0;
		}
		cout << tmp_str << endl;
		if( direct == true)
			cout << "found Direct coordinates " << endl;
		else
			cout << "found Cartesian coordinates " << endl;
		*/
	}
	// get atom positions
	for(i=0;i<sum_num_atoms;i++)
	{	getline(infile2,tmp_str);
		//cout << tmp_str << endl;
		vector<double> v;
		double x;
		istringstream ss (tmp_str,istringstream::in);
		for( j=0;j<3;j++)
		{	ss >> x;
			v.push_back(x);
		}
		atom_pos.push_back(v);
			
	}	
	infile2.close();
	
	// print atom positions 
	/*cout << "here 2" << endl;
	for(i=0;i<sum_num_atoms;i++)
	{
		for(j=0;j<3;j++)
		{
			cout << atom_pos[i][j] << " " ;
		}
		cout << endl;
	}
	cout << "here 3" << endl;
	*/

	// move to last output of electrostatic potential at cores
	//cout << "begin open OUTCAR" << endl;
	infile3.open(outcar.c_str());
	//cout << "opened" << endl;
	int num_lines = 0;
	bool cont = true;
	num_electrostatic = 0;
	while( cont == true && getline(infile3,tmp_str))
	{
		if( tmp_str.find("electrostatic")!=string::npos)
		{
			num_electrostatic++;
		}
		
		
		if( num_electrostatic == tot_num_electrostatic)
		{
			cont = false;
		}
	}
	
	//cout << tmp_str << endl;
	getline(infile3,tmp_str);
	//cout << tmp_str << endl;
	getline(infile3,tmp_str);
	//cout << tmp_str << endl;
	
	int atom_count = 0;
	double pot;
	int curr_type = 0;
	// get electrostatic potential at each atom core
	while( atom_count < sum_num_atoms && getline(infile3,tmp_str))
	{
		//cout << tmp_str << endl;
	
		istringstream ss (tmp_str,istringstream::in);
			
		for( i=0;i<5;i++)
		{
			ss >> atom_count >> pot;
			if( atom_count > cum_num_atoms[curr_type])
				curr_type++;
				
			atom_pot.push_back(pot);
			//cout << "atom_pot: " << atom_pot[ atom_pot.size()] << endl;
			atom_type.push_back(curr_type);
			atom_pot_shift.push_back(0);
			if( atom_count == sum_num_atoms)
				i = 5;
		}
			
	}
	
	infile3.close();

	//cout << "close OUTCAR" << endl;	
	int ii,jx,jy,jz;
	double r[3] = {0,0,0};
	double defect_image_pos[3] = {0,0,0};
	double dist_r;
	double min_r;
	double dx[3] = {0,0,0};
	double ax[3] = {0,0,0};
	
	r[0] = sqrt(lat_vectors[0][0]*lat_vectors[0][0] + lat_vectors[0][1]*lat_vectors[0][1] + lat_vectors[0][2]*lat_vectors[0][2]);
	r[1] = sqrt(lat_vectors[0][0]*lat_vectors[0][0] + lat_vectors[0][1]*lat_vectors[0][1] + lat_vectors[0][2]*lat_vectors[0][2]);
	r[2] = sqrt(lat_vectors[0][0]*lat_vectors[0][0] + lat_vectors[0][1]*lat_vectors[0][1] + lat_vectors[0][2]*lat_vectors[0][2]);
	
	double start_min_r = r[0] + r[1] + r[2];
	bool closer_found;
	int n;
	for( ii=0;ii<num_defects;ii++)
	for( i=0;i<sum_num_atoms;i++)
	{
	
		min_r = start_min_r;
		atom_def_r.push_back(min_r);
	
		for(j=0;j<3;j++)
		{
			while( atom_pos[i][j] < defect_pos[ii][j])
				atom_pos[i][j] += 1;
				
			while( atom_pos[i][j] >= defect_pos[ii][j]+1)
				atom_pos[i][j] -= 1;
		}
	
		closer_found = true;
		n=0;
		while( closer_found == true)
		{
			closer_found = false;
			// check distance to nth shell of defects
			for( jx=-n;jx<=n+1;jx++)
			for( jy=-n;jy<=n+1;jy++)
			for( jz=-n;jz<=n+1;jz++)
			{
				// if nth shell
				if( jx == -n || jy == -n || jz == -n || jx == n+1 || jy == n+1 || jz == n+1)
				{
					defect_image_pos[0] = defect_pos[ii][0] + jx;
					defect_image_pos[1] = defect_pos[ii][1] + jy;
					defect_image_pos[2] = defect_pos[ii][2] + jz;
					
					dx[0] = lat_vectors[0][0]*defect_image_pos[0] + lat_vectors[1][0]*defect_image_pos[1] + lat_vectors[2][0]*defect_image_pos[2];
					dx[1] = lat_vectors[0][1]*defect_image_pos[0] + lat_vectors[1][1]*defect_image_pos[1] + lat_vectors[2][1]*defect_image_pos[2];
					dx[2] = lat_vectors[0][2]*defect_image_pos[0] + lat_vectors[1][2]*defect_image_pos[1] + lat_vectors[2][2]*defect_image_pos[2];
					
					ax[0] = lat_vectors[0][0]*atom_pos[i][0] + lat_vectors[1][0]*atom_pos[i][1] + lat_vectors[2][0]*atom_pos[i][2];
					ax[1] = lat_vectors[0][1]*atom_pos[i][0] + lat_vectors[1][1]*atom_pos[i][1] + lat_vectors[2][1]*atom_pos[i][2];
					ax[2] = lat_vectors[0][2]*atom_pos[i][0] + lat_vectors[1][2]*atom_pos[i][1] + lat_vectors[2][2]*atom_pos[i][2];
					
				
					for( j=0;j<3;j++)
						r[j] = ax[j] - dx[j];
						
					dist_r = sqrt( r[0]*r[0] + r[1]*r[1] + r[2]*r[2]);
					
					if( dist_r < atom_def_r[i])
					{
						atom_def_r[i] = dist_r;
						closer_found = true;
					}
				}
			}
			n++;
		}
	
	
	}
	//cout << "finish calc atom_def_r" << endl;
	//for( i=0;i<sum_num_atoms;i++)
	//{
	//	cout << "atom: " << i << " type: " << atom_types[ atom_type[i]] << " pos: " << atom_pos[i][0] << " " << atom_pos[i][1] << " " << atom_pos[i][2] << "  potential: " << atom_pot[i] << "  atom_def_r: " << atom_def_r[i] << endl;
	//
	//}
	
	
	// bubble sort by distance to defect
	double tmp_pot;
	double tmp_r;
	int tmp_type;
	double tmp_pos[3] = {0,0,0};
	for( i=sum_num_atoms-1;i>0;i--)
	{
		//cout << "i: " << i << endl;
		for( j=0;j<i;j++)
		{
			//cout << "j: " << j << endl;
			if( atom_def_r[j] < atom_def_r[j+1])
			{
				//cout << "swap" << endl;
				// swap
				tmp_pot = atom_pot[j];
				tmp_r = atom_def_r[j];
				tmp_type = atom_type[j];
				
				for(k=0;k<3;k++)
					tmp_pos[k] = atom_pos[j][k];
						
				atom_pot[j] = atom_pot[j+1];
				atom_def_r[j] = atom_def_r[j+1];
				atom_type[j] = atom_type[j+1];
				for(k=0;k<3;k++)
					atom_pos[j][k] = atom_pos[j+1][k];
				
				atom_pot[j+1] = tmp_pot;
				atom_def_r[j+1] = tmp_r;
				atom_type[j+1] = tmp_type;
				for(k=0;k<3;k++)
					atom_pos[j+1][k] = tmp_pos[k];
				
			
			}
			
			
			
		}
	}
	cout << endl << "Atoms sorted by distance to defect: " << endl;	
	for( i=0;i<sum_num_atoms;i++)
	{
		cout << "atom: " << i << " type: " << atom_types[ atom_type[i]] << " pos: " << atom_pos[i][0] << " " << atom_pos[i][1] << " " << atom_pos[i][2] << "  potential: " << atom_pot[i] << "  atom_def_r: " << atom_def_r[i] << endl;
	}
	


	
	
	int cutoff = 0;
	int atom_type_count[ host_types.size()];
	int tot_host_count = 0;
	double host_min_shift[ host_types.size()];
	double host_max_shift[ host_types.size()];
	double host_sum_shift[ host_types.size()];
	double host_mean_shift[ host_types.size()];
	double tot_mean_shift = 0.0;
	double host_stdev_shift[ host_types.size()];
	double tot_stdev_shift = 0.0;
	int farthest_host_atom = -1;
	
	for( i=0;i<host_types.size();i++)
	{
		atom_type_count[i] = 0;
		host_sum_shift[i] = 0.0;
		host_mean_shift[i] = 0.0;
		host_stdev_shift[i] = 0.0;
	}
	
	cout << endl << "Atoms in-range: " << endl;
	if( range < 0) range = sum_num_atoms;
	cont = true;
	i = 0;
	while( cont == true && i < sum_num_atoms)
	{
		cutoff++;
		for(j=0;j<host_types.size();j++)
		{
			if( atom_types[atom_type[i]].compare( host_types[j]) == 0)
			{
				if( farthest_host_atom == -1)
					farthest_host_atom = i;
			
				atom_type_count[j]++;
				atom_pot_shift[i] = atom_pot[i] - host_perf_pot[j];
				
				
				cout << "i: " << i << "  type: " << atom_types[atom_type[i]] << "  dist to def: " << atom_def_r[i] << "  pot_shift: " << atom_pot_shift[i] << endl;
			
				if( atom_type_count[j] == 1)
				{
					host_min_shift[j] = atom_pot_shift[i];
					host_max_shift[j] = atom_pot_shift[i];
				}
				else
				{
					if( atom_pot_shift[i] > host_max_shift[j])
						host_max_shift[j] = atom_pot_shift[i];
						
					if( atom_pot_shift[i] < host_min_shift[j])
						host_min_shift[j] = atom_pot_shift[i];
				}
				
				host_sum_shift[j] += atom_pot_shift[i];
				
				// check if we've found 'range' # of atoms of each host type
				cont = false;
				for( k=0;k<host_types.size();k++)
				{
					if( atom_type_count[k] < range)
						cont = true;
				}
				
				
				
				j = host_types.size();
			}
		
		}
	
		i++;
	}
	
	// calculate mean shift for each type
	for(j=0;j<host_types.size();j++)
	{
		host_mean_shift[j] = host_sum_shift[j]/(1.0*atom_type_count[j]);
		tot_mean_shift += host_sum_shift[j];
		tot_host_count += atom_type_count[j];
	}
	tot_mean_shift = tot_mean_shift/(1.0*tot_host_count);
	
	// calculate standard deviation for each type
	for(i=0;i<cutoff;i++)
	{
		for(j=0;j<host_types.size();j++)
		{
			if( atom_types[atom_type[i]].compare( host_types[j]) == 0)
			{
				// first get sum (shift - mean)^2
				host_stdev_shift[j] += (atom_pot_shift[i] - host_mean_shift[j])*(atom_pot_shift[i] - host_mean_shift[j]);
				tot_stdev_shift += (atom_pot_shift[i] - tot_mean_shift)*(atom_pot_shift[i] - tot_mean_shift);
				j = host_types.size();
			}
		}
	}
	for(j=0;j<host_types.size();j++)
	{
		host_stdev_shift[j] = sqrt( host_stdev_shift[j]/(1.0*atom_type_count[j]));
		tot_stdev_shift = sqrt( tot_stdev_shift/(1.0*tot_host_count));
	}
	
	// average potential shift of the farthest atom of each host_atom_type
	bool far_found[host_types.size()];
	for(i=0;i<host_types.size();i++) far_found[i] = false;
	int num_found = 0;
	double far_shift[host_types.size()];
	double mean_far_shift = 0;
	for(i=0;i<sum_num_atoms;i++)
	{
		for(j=0;j<host_types.size();j++)
		{
			if( atom_types[atom_type[i]].compare( host_types[j]) == 0)
			{
				if( far_found[j] == false)
				{
					far_found[j] = true;
					num_found++;
					far_shift[j] = atom_pot_shift[i];
					mean_far_shift += atom_pot_shift[i];
					if(num_found == host_types.size())
						i = sum_num_atoms;
				}
				j = host_types.size();
			}
			
		}
	}
	
	mean_far_shift /= (1.0*host_types.size());
	
	// output results
	cout << "mean farthest host atom potential shift: " << mean_far_shift << endl;
	cout << "farthest atom potential shift: " << atom_pot_shift[farthest_host_atom] << endl;
	cout << "mean in-range host potential shift: " << tot_mean_shift << "  in-range host stdev: " << tot_stdev_shift << endl;
	for(j=0;j<host_types.size();j++)
	{
		cout << "host type: " << host_types[j] << "  min: " << host_min_shift[j] << "  max: " << host_max_shift[j] << "  farthest: " << far_shift[j] << "  n: " << atom_type_count[j] << "  stdev: "<< host_stdev_shift[j] << endl;
	}
	
		
	
	// find position farthest from defect
	
	// find atom farthest from defect, use that atoms's potential for shift
	
	// then take mean/std dev for all atoms less than eps from that farthest point 
	//	with eps set to include each type of host atom at least twice.
	
	
	
	
	
}
