#ifndef projdata_comp
#define projdata_comp

#include <vector>
#include <string>
#include <iostream>
#include <complex>
#include "matrix.h"
#include "typedefs.h"

class projdata
{
public:
  // Constructors
  projdata(); // default
  void Print(ostream & outf);
  // variables
  int nl_max; // 4 for s,p,d,f orbitals
  int nlm_max; // 16 for s,p,d,f orbitals
  int nlmtot_max; // 20 for s,p,d,f orbitals + p,d,f,all totals
  int nl; // 3 for spd
  int nlm; // 9 for spd
  int nlmtot; // 9+Psum+Dsum+Allsum=12 (for spd)
  int nkpts;
  int nbands;
  int nions;
  int ntypes;
  vector<int> num_each_type;
  matrix<double> wfermi_u;
  matrix<double> wfermi_d;
  vector<double> wkpt;
  vector<matrix<matrix<complex<double> > > > pdat_u;
  vector<matrix<matrix<complex<double> > > > pdat_d;
  matrix<matrix<double> > occ_vs_ion_kpt_bnd_lm_u;
  matrix<matrix<double> > occ_vs_ion_kpt_bnd_lm_d;
  matrix<matrix<double> > occ_vs_ion_kpt_bnd_l_u;
  matrix<matrix<double> > occ_vs_ion_kpt_bnd_l_d;
  matrix<matrix<double> > occ_vs_ion_kpt_bnd_lmtot_u;
  matrix<matrix<double> > occ_vs_ion_kpt_bnd_lmtot_d;
  vector<matrix<double> > occ_vs_ion_kpt_lm_u;
  vector<matrix<double> > occ_vs_ion_kpt_lm_d;
  vector<matrix<double> > occ_vs_ion_kpt_l_u;
  vector<matrix<double> > occ_vs_ion_kpt_l_d;
  vector<matrix<double> > occ_vs_ion_bnd_lm_u;
  vector<matrix<double> > occ_vs_ion_bnd_lm_d;
  vector<matrix<double> > occ_vs_ion_bnd_l_u;
  vector<matrix<double> > occ_vs_ion_bnd_l_d;
  matrix<double> occ_vs_ion_lm_u;
  matrix<double> occ_vs_ion_lm_d;
  matrix<double> occ_vs_ion_l_u;
  matrix<double> occ_vs_ion_l_d;
  matrix<double> ener_k_b_u;
  matrix<double> ener_k_b_d;
  int sp;
  int rspin;
  matrix<double> kpts;
  vector<string> LMnames;
  vector<string> Lnames;
  vector<string> LLMnames;
  string PROOUTinfile;
  matrix<double> lat;
};

#endif


