// **************************************************
// PrintChgInt
// **************************************************
//  This funtion prints out 3 lattice vectors in cartesian coordinates.

#include <math.h>
#include <string>
#include <iostream.h>
#include <fstream.h>
#include <iomanip.h>
#include "UsefulFuncs.h"
#include "atom.h"
#include "PrintChgInt.h"
#include "GetChgInt.h"
#include <vector.h>

void PrintChgInt()
{  
  cout.setf(ios::left, ios::adjustfield);
  cout.setf(ios::fixed, ios::floatfield);
  vector<matrix<double> > rad_chg_int;
  matrix<double> vor_chg_int;
  GetChgInt(rad_chg_int,vor_chg_int);

  // Output Voronoi data
  cout << "******************** Charge in Voronoi volume: Tot Diff Up Dn ********************" << endl;
  for (int iat=0;iat<vor_chg_int.size();iat++){
    cout << iat+1;
    for (int i=0;i<4;i++){
      cout << " " << vor_chg_int[iat][i];
    }
    cout << endl;
  }

  // Output Radial data
  cout << "******************** Charge in sphere: Tot Diff Up Dn ********************" << endl;
  for (int iat=0;iat<rad_chg_int.size();iat++){
    cout << "Atom " << iat+1 << endl;
    for (int ib=0;ib<rad_chg_int[iat].size();ib++){
      cout << "  " << rad_chg_int[iat][ib][0];
      for (int i=1;i<5;i++){
        cout << " " << rad_chg_int[iat][ib][i];
      }
      cout << endl;
    }
  }


} // end routine

