#ifndef RBFuncs_comp
#define RBFuncs_comp

#include "matrix.h"
#include <vector>
#include <string>
#include "typedefs.h"

vector<string> GetRBDir(const int & nim);
vector<double> GetRBEner(const int & nim);
vector<structure> GetRBStruct(const int & nim);
vector<double> GetRBDistCum(const vector<structure> & str_vec, 
			    const string & path_flag);
void RBPoscarDisp(const structure & str1in, const structure & str2in,
		  structure & dispstr, double & totdist, matrix<double> & cm,
		  const string & path_flag);
void PrintRBPoscarDisp(const structure & diffstr, double & totdist, 
		       matrix<double> & cm, const string & path_flag, 
		       ostream & outf);
double TotalAtomDist(structure str, structure str00, const string & path_flag);
void PrintRBAnal(const int & nim, const string & path_flag, ostream & outf);

#endif




