#ifndef ChgFuncs_comp
#define ChgFuncs_comp

#include "typedefs.h"
#include "structure.h"
#include "matrix.h"

class pd_params
{
 public:
  string type;
  double scale;
  matrix<double> pts;
  matrix<double> dpts;
  int Nx,Ny;
  string orig_loc;
  string ortho;
  void Print(ostream & outf) const;
};

void ReadChg(structure & str,
	     vector<int> & ngrid,
	     vector<double> & chg_tot, 
	     vector<double> & chg_diff, 
	     istream & chgfile);
void GetChgInt(vector<matrix<double> > & rad_chg_int, 
	       matrix<double> & vor_chg_int,
	       structure & str,
	       vector<int> & ngrid,
	       vector<double> & chg_tot, 
	       vector<double> & chg_diff);
void PrintChgInt(vector<matrix<double> > & rad_chg_int, 
		 matrix<double> & vor_chg_int);
void ReadPlaneDensParams(const structure & str, pd_params & pdp, istream & infile);
void GetPlaneDens(const pd_params & pdp, 
		  vector<double> & dens2d_tot,
		  vector<double> & dens2d_diff,
		  const structure & str,
		  const vector<int> & ngrid,
		  const vector<double> & chg_tot, 
		  const vector<double> & chg_diff);
void PrintPlaneDens(const pd_params & pdp, 
		    const vector<double> & dens2d_tot,
		    const vector<double> & dens2d_diff,
		    const structure & str);
void PrintCHGCAR(const structure & str,
		 const vector<int> & ngrid,
		 const vector<double> & chg_tot, 
		 const vector<double> & chg_diff);


#endif



