// pdosdata object. 

using namespace std;
#include <iostream>
#include <iomanip>
#include "pdosdata.h"
#include "UsefulFuncs.h"


// Constructors
pdosdata::pdosdata()
{

}
  
void pdosdata::PrintParams(ostream & outf, const vector<string> & Ltotnames)
{
  outf << "EMIN = " << emin << endl;

  outf << "EMAX = " << emax << endl;
  outf << "EFERMI = " << efermi << endl;
  outf << "NBINS = " << nbins << endl;
  outf << "SPIN = " << spin << endl;
  outf << "NLM = " << nlm << endl;
  outf << "NATOMS = " << natoms << endl;
  outf << "SMOOTH_SIGMA = " << smooth_sigma << endl;
  outf << "PRINT_PARAMS = " << print_params << endl;
  for (int i=0;i<pdos_at.size();i++){
    outf << "# CASE = " << i+1 << endl;
    outf << "  ATOMS = ";
    Vout(pdos_at[i],outf);
    if (pdos_k.size()>0){
      outf << "  KPOINTS = ";
      Vout(pdos_k[i],outf);
    }
    if (pdos_b.size()>0){
      outf << "  BANDS = ";
      Vout(pdos_b[i],outf);
    }
    outf << "  LMVALUES = ";
    Vout(pdos_lm[i],outf);
    outf << "  # ( LMVALUES = ";
    for (int j=0;j<pdos_lm[i].size();j++){
      outf << " " << Ltotnames[pdos_lm[i][j]-1];
    }
    outf << " )" << endl;
  }

}


void pdosdata::PrintPDOS(ostream & outf, const int & sp)
{
  outf.precision(5);
  outf.setf(ios::fixed,ios::floatfield);
  outf.setf(ios::left,ios::adjustfield);

  if (sp==0) outf << "# Energy         Up            Cumulative_Up" << endl;
  if (sp==1) outf << "# Energy         Up             Dn             Up-Dn        Cumulative_Up   Cumulative_Dn   Cumulative_Up-Dn" << endl;
  for (int ib=0;ib<pdos.size();ib++){
    for (int i=0;i<pdos[ib].size();i++){
      outf << setw(10) << pdos[ib][i] << "     ";
    }
    outf << endl;
  }

}










