#ifndef pdosdata_comp
#define pdosdata_comp

#include <vector>
#include <string>
#include <iostream>
#include <complex>
#include "matrix.h"
#include "typedefs.h"

class pdosdata
{
public:
  // Constructors
  pdosdata(); // default
  void PrintParams(ostream & outf, const vector<string> & Ltotnames);
  void PrintPDOS(ostream & outf, const int & sp);
  // variables
  string PDOSinfile;
  matrix<int> pdos_at;
  matrix<int> pdos_k;
  matrix<int> pdos_b;
  matrix<int> pdos_lm;
  matrix<double> pdos;
  double emin;
  double emax;
  double efermi;
  double smooth_sigma;
  int spin;
  int nlm;
  int natoms;
  int print_params;
  int nbins;
};

#endif


