#ifndef RDFuncs_comp
#define RDFuncs_comp

#include "matrix.h"
#include "structure.h"
#include <vector>
#include <string>
#include "typedefs.h"

void GetRDF(const structure & str, const double & rmax,
	    const int & nbins, matrix<double> & rdf_all);
void GetRDFShells(const structure & str,const double & rmax,
		  const int & nbins,
		  const int & smooth_width,
		  const matrix<double> & rdf_all, 
		  matrix<double> & rdfsh_all,
		  matrix<double> & rdfsh_loc);
void PrintRDF(const structure & str, const double & rmax,
	      const int & nbins,
	      const int & smooth_width,
	      const matrix<double> & rdf_all, 
	      matrix<double> & rdfsh_all,
	      matrix<double> & rdfsh_loc,
	      ostream & outf);
void CmpRDFShells(const structure & str_A, const structure & str_B,
	     const matrix<double> & rdfsh_all_A,
	     const matrix<double> & rdfsh_all_B,
	     const int nsh, vector<int> & best_match,
	     matrix<double> & rms_mat);
double RdfSh_RMS(const int iaA, const int iaB, const int nsh,
		 const int nt,
		 const matrix<double> & rdfsh_all_A,
		 const matrix<double> & rdfsh_all_B);
void PrintRDFCmp(const structure & str_A, const structure & str_B,
		 const double & rmax, const int nbins,
		 const double & smooth_width,const int nsh,
		 const matrix<double> & rdfsh_all_A,
		 const matrix<double> & rdfsh_all_B,
		 const vector<int> & best_match,
		 const matrix<double> & rms_mat, ostream & outf);
matrix<double> GetSmoothRDF(const matrix<double> & rdf,const double & sigma);
#endif




