#ifndef RayTraceFuncs_comp
#define RayTraceFuncs_comp

#include <iostream>
#include <sstream>
#include <fstream>
#include <vector>
#include "structure.h"
#include "matrix.h"
#include "rtparams.h"
#include "typedefs.h"

void GetDatFromOutcar(vector<matrix<double> > & lat_vec, 
		      vector<int> & num_each_type, ifstream & outcar_inf);
void GetDatFromXdatcar(vector<matrix<double> > & dpos_vec, 
		       ifstream & xdatcar_inf);
vector<structure> GetStrVecFromOUTCAR_XDATCAR(ifstream & outcar_inf, ifstream & xdatcar_inf);
void PrintStrVec(const vector<structure> & str_vec, ostream & outf);
void RayTraceManager(char * argv[]);
void ReadInRTParams(ifstream & rtinfile, rtparams & rtp);
void ReadInStrVec(vector<structure> & str_vec, ifstream & strlist_inf);
void JoinStrVec(vector<structure> str_vec_1,
		vector<structure> str_vec_2,
		vector<structure> & str_vec_tot);
void SetStrFromRTParams(structure & str, rtparams & rtp);
void SetRTParams(structure & str, rtparams & rt_params);
void GetRTDatFile(structure str, const rtparams & rt_params,
		  ostringstream & rtdat_file);
string PrintRTDatFile(ostringstream & rtdat_file, const rtparams & rt_params);
string CreateRTtgaFile(const string & datfile, const rtparams & rt_params);
string CreateRTjpgFile(const string & tgafile, const rtparams & rt_params);
void GetRTencFile(const rtparams & rtp, const int nim, ostringstream & os);
string PrintRTencFile(const rtparams & rt_params, ostringstream & rtenc_file);
string CreateRTmpgFile(const rtparams & rt_params, const string & encfile);
void SuperCellStrVec(vector<structure> & str_vec, const matrix<double> & sc);
void RotateStrVec(vector<structure> & str_vec, const vector<double> & rot);
matrix<double> GetRotationMatrix(const vector<double> & angles); 
void UpDateRTParams(rtparams & rtp, const int & istr, int nstr);
#endif







