#ifndef atom_comp
#define atom_comp

#include <string>
#include "matrix.h"
#include <vector>
#include "typedefs.h"

class atom
{
public:
  // Constructors
  atom(); // default
  atom(const atom & b); // copy
  // Mutators
  void SetName(const string & in_name);
  void SetType(const int in_type);
  void SetNum(const int in_num);
  void SetUnitCell(const vector<int> & in_unit_cell);
  void SetCpos(const vector<double> & in_cpos);
  void SetDpos(const vector<double> & in_dpos);
  void SetCOrigin(const vector<double> & in_origin);
  // Accessors
  string GetName() const;
  int GetType() const;
  int GetNum() const;
  vector<int> GetUnitCell() const;
  vector<double> GetCpos() const;
  vector<double> GetDpos() const;
  vector<double> GetCOrigin() const;
  vector<double> GetCDispFromOrigin() const;
  double GetDistFromOrigin() const;
  // Operators
  const atom & operator=(const atom & b);
  const void Print(ostream & sout);
 private:
  void free();
  void copy(const atom & b);
  string name;
  int type;
  int num;
  vector<int> unit_cell;
  vector<double> cpos;  
  vector<double> dpos;
  vector<double> corigin;
};

#endif








