#!/usr/bin/env python

import os
import sys
import subprocess
import math
import Xinputmatch

def main():
    """
        inputfcc file:
        symbol = 
        a = 
        x = 3 (number of cell repetitions
        y = 3
        z = 3
    """
    
    dict = {}
    catparam = "symbol.a.x.y.z"
    cwd = os.getcwd()
    dict = Xinputmatch.main(cwd + "/inputfcc",catparam,1)

    if(dict == None):
        print "Error in inputfcc file parameter extraction"
        return None

    symbol = dict['symbol']
    a = dict['a']
    x = dict['x']
    y = dict['y']
    z = dict['z']

    while(len(a) < 12):
        a += '0'
            
    filename = "primitive_POSCAR_" + symbol

    writef = open(filename,'wb')
    writef.write(symbol + '\n')
    writef.write("1.0000000000\n")
    writef.write(a + " 0.0000000000 0.0000000000\n")
    writef.write("0.0000000000 " + a + " 0.0000000000\n")
    writef.write("0.0000000000 0.0000000000 " + a + '\n')
    writef.write(symbol + '\n')
    writef.write("4\n")
    writef.write("D\n")
    writef.write("0.0000000000 0.0000000000 0.0000000000\n")
    writef.write("0.0000000000 0.5000000000 0.5000000000\n")
    writef.write("0.5000000000 0.0000000000 0.5000000000\n")
    writef.write("0.5000000000 0.5000000000 0.0000000000\n")    
    writef.close()
    
    writef = open(cwd + "/matrix", 'wb')
    writef.write(x + " 0 0\n")
    writef.write("0 " + y + " 0\n")
    writef.write("0 0 " + z + '\n')
    writef.close()

    arg = "convasp -supercell matrix < primitive_POSCAR_" + symbol + " > POSCARFINAL_" + symbol
    subprocess.Popen(arg,shell=True)
    
