#!/usr/bin/env python

import os
import sys
import subprocess
import math
import Xinputmatch
import shlex

def main():
    """
        inputhcp file:
        symbol = Ti
        a = 2.95
        c/a = 1.588
        x = 3 (number of cell repetitions
        y = 3
        z = 2
    """
    
    dict = {}
    catparam = "symbol.a.c/a.x.y.z"
    cwd = os.getcwd()
    dict = Xinputmatch.main(cwd + "/inputhcp",catparam,1)

    if(dict == None):
        print "Error in inputhcp file parameter extraction"
        return None

    symbol = dict['symbol']
    a = dict['a']
    crat = dict['c/a']
    x = dict['x']
    y = dict['y']
    z = dict['z']

    c = str(float(crat)*float(a))
    halfa = str(float(a)/2.0)
    sqrt3halfa = str( round( ( (float(a)/2)*math.sqrt(3) ) ,8) )
    
    while(len(a) < 12):
        a += '0'
    while(len(halfa) < 12):
        halfa += '0'
    while(len(sqrt3halfa) < 12):
        sqrt3halfa += '0'
    while(len(c) < 12):
        c += '0'
        
    filename = "primitive_POSCAR_" + symbol

    writef = open(filename,'wb')
    writef.write(symbol + '\n')
    writef.write("1.0000000000\n")
    writef.write(a + " 0.0000000000 0.0000000000\n")
    writef.write(halfa + " " + sqrt3halfa + " 0.0000000000\n")
    writef.write("0.0000000000 0.0000000000 " + c + '\n')
    writef.write(symbol + '\n')
    writef.write("2\n")
    writef.write("D\n")
    writef.write("0.0000000000 0.0000000000 0.0000000000\n")
    writef.write("0.3333333333 0.3333333333 0.5000000000\n")
    writef.close()
    
    writef = open(cwd + "/matrix", 'wb')
    writef.write(x + " 0 0\n")
    writef.write("0 " + y + " 0\n")
    writef.write("0 0 " + z + '\n')
    writef.close()

    arg = "convasp -supercell matrix < primitive_POSCAR_" + symbol + " > POSCARFINAL_" + symbol
    subprocess.Popen(arg,shell=True)
    
