#!/usr/bin/env python
##
#@package   Xvalidletter
#@ingroup   other
#@ingroup   python
#@brief     checks to see if an input is a valid letter in a given range
#@author    Tam Mayeshiba
#@date      11/30/10 
###
def main(checklett, lettlist=[], nolistcheck=0):
    """
    Purpose:
        inputs:  
            [$1] input to check
                example: 't'
            [$2] allowed letter list: lowercase
                example: ['y', 'n']
            [$3] 0 - check letter list (default)
                 1 - letter list should be good; skip check
        outputs:
            returns the letter if it is good
            None - input failed a check
        notes:
            Allowed letter list and letter to check will become lowercase.
            Therefore, please do not differentiate options by upper- and
            lower-case (e.g. 'G' should not go somewhere different than 'g')
    """
#   Modules:
#    import os
#    import sys
    import Xvalidinteger
#   
#   #   check nolistcheck
    nolistcheck = Xvalidinteger.main(nolistcheck, 0, 1)
    if nolistcheck == None:
        return None
#   #   check letter list unless switch is off
    if (nolistcheck != 1):
        if type(lettlist) <> list:
            print 'No valid list of allowed options was supplied.'
            return None
        lettct=0
        lettct = len(lettlist)
        onelett=""
        for lettct in range(len(lettlist)):
            onelett = lettlist[lettct]
            try:
                onelett = str(onelett)
            except (ValueError, TypeError):
                print onelett, 'should be a letter.'
                return None
            onelett = onelett.lower()
            lettlist[lettct] = onelett
#        for onelett in lettlist:
#            print onelett               #debug
#   #   check input
    if (checklett == None):
        print checklett, 'should be a letter.'
        return None
    try:
        checklett = str(checklett)
    except (ValueError, TypeError):
        print checklett, 'should be a letter.'
        return None
    if (len(checklett) < 1):
        print checklett, 'should be a letter.'
        return None
    checklett = checklett[0]
    checklett = checklett.lower()
    if (checklett in lettlist):
        return checklett
    else:
        print checklett, 'is not a valid option.'
        return None
