#!/usr/bin/env python
##
#@package   taccneb 
#@ingroup   vasp
#@ingroup   python
#@brief     restart NEB according to Ming-Jie's criteria for TACC/Lonestar
#@author    Tam Mayeshiba
#@date      3/2/12
###
"""
Purpose: restart NEB for TACC/lonestar
inputs:
    top directory (which houses folder): example my_neb
    matching string for output file (default: '.*[.][o].*')
    matching string for finished neb (default: 'reached required')
output:
"""
import os
import sys
import time
import re
import subprocess
import shutil
#import pdb
# defaults
#pdb.set_trace()
mydir = os.getcwd()
output = '.*[.][o].*'
accstr = '\'reached required\''

if len(sys.argv) > 1:
    mydir = sys.argv[1]
if len(sys.argv) > 2:
    output = sys.argv[2]
if len(sys.argv) > 3:
    accstr = str(sys.argv[3])

mydir = os.path.abspath(mydir)
if not os.path.exists(mydir):
    print 'Directory', mydir, 'could not be found. Exiting.'
    sys.exit(0)

fname=""
listdir=[]
files=[]
grepproc=""
grepstr=""
fullpath=""
acc=""
dirlist=[]
match=""

listdir = os.listdir(mydir)
for fname in listdir:
    fullpath = os.path.join(mydir, fname)
    if os.path.isfile(fullpath):
        match = re.match(output, fname)
        if not match == None:
            files.append(fullpath)
    elif os.path.isdir(fullpath):
        match = re.match('0?[1-9]?[1-9]?',fname)
        if not match == None:
            dirlist.append(fullpath)
files.sort()
dirlist.sort()

if len(files) == 0:
    print 'No output files matching', output, 'found. Exiting.'
    sys.exit(0)

lastfile = os.path.join(mydir,files[len(files)-1])
print 'Using output file: ',lastfile
grepstr = 'grep ' + accstr + ' ' + lastfile
grepproc = subprocess.Popen(grepstr, shell=True, stdout = subprocess.PIPE)
grepproc.wait()
acc = grepproc.communicate()[0]

imdir=""
dirct=0
oldpath=""
newpath=""
i=1
contcar=""
if acc == None or acc == '':
    print 'No accuracy tags in output file.'
    print 'Archiving old outputs.'
    print str(len(dirlist)-2), 'image(s) detected.'    
    while dirct < len(dirlist)-2:
        dirct = dirct + 1
        imdir = dirlist[dirct]
        for item in ['OUTCAR','POSCAR','CONTCAR','OSZICAR']:
            oldpath = os.path.join(imdir,item)
            if os.path.isfile(oldpath):
                newpath = os.path.join(imdir,item + '1')
                i=1
                while i<50 and os.path.isfile(newpath):
                    i = i+1
                    newpath = os.path.join(imdir, item + str(i))
                shutil.copy(oldpath, newpath)
                print '...', item, '...'
        contcar = os.path.join(imdir,'CONTCAR')
        if int(os.path.getsize(contcar)) == 0:
            pass
        else:
            shutil.copy(contcar,os.path.join(imdir,'POSCAR'))
            print 'Copied', contcar, 'to POSCAR.'
else:
    print 'Job appears to be complete.'
    
